// This program uses the USB HID DLL posted to LibStock by Dany dany.ross@edpnet.be

unit HIDform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  HID_Intf, Menus
  ;

type
  THIDtestForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Clear1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Setup1: TMenuItem;
    ShowDateTime1: TMenuItem;
    SetDateTime1: TMenuItem;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Scan1: TMenuItem;
    SaveDialog1: TSaveDialog;
    WiFiPlus1: TMenuItem;
    Panel1: TPanel;
    Edit1: TEdit;
    Button1: TButton;
    HwReset1: TMenuItem;
    SwReset2: TMenuItem;
    Ping1: TMenuItem;
    GetVersion1: TMenuItem;
    GetKey1: TMenuItem;
    N3: TMenuItem;
    GetNetworkStatus1: TMenuItem;
    ScanforAccessPoints1: TMenuItem;
    SetWiFiParameters1: TMenuItem;
    ConnecttoAccessPoint1: TMenuItem;
    DisconnectfromAccessPoint1: TMenuItem;
    CreateUDPsocket1: TMenuItem;
    CloseSocket1: TMenuItem;
    BindSocket1: TMenuItem;
    ConnectSocket1: TMenuItem;
    SendSocket1: TMenuItem;
    SendToCommand1: TMenuItem;
    ReceiveFromCommand1: TMenuItem;
    DoUDPServer1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ShowDateTime1Click(Sender: TObject);
    procedure SetDateTime1Click(Sender: TObject);
    procedure Scan1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure HwReset1Click(Sender: TObject);
    procedure SwReset2Click(Sender: TObject);
    procedure Ping1Click(Sender: TObject);
    procedure GetVersion1Click(Sender: TObject);
    procedure GetKey1Click(Sender: TObject);
    procedure GetNetworkStatus1Click(Sender: TObject);
    procedure ScanforAccessPoints1Click(Sender: TObject);
    procedure SetWiFiParameters1Click(Sender: TObject);
    procedure ConnecttoAccessPoint1Click(Sender: TObject);
    procedure DisconnectfromAccessPoint1Click(Sender: TObject);
    procedure CreateUDPsocket1Click(Sender: TObject);
    procedure CloseSocket1Click(Sender: TObject);
    procedure BindSocket1Click(Sender: TObject);
    procedure ConnectSocket1Click(Sender: TObject);
    procedure SendSocket1Click(Sender: TObject);
    procedure SendToCommand1Click(Sender: TObject);
    procedure ReceiveFromCommand1Click(Sender: TObject);
    procedure DoUDPServer1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetFirstToken(S: string; Token: Char): string;
    function StripFirstToken(S: string; Token: Char): string;
    function Int2StrPad0(N: LongInt; Len: Integer): string;
    function CleanString(S: string): string;

    procedure SendOut;
    procedure ScanForDevices;
    procedure ShowDevices(Nr: Integer; Device: THIDdeviceInfo);
  end;

var
  HIDtestForm: THIDtestForm;
  ProgDir: string;



implementation
{$R *.dfm}

const
  CRLF = #13+#10;
  LF   = #10;

var
  CurrentDevice: integer = -1;
  NumDevices: byte;
  SendStr: AnsiString;
  Report: THIDReport;





//******************************************************************************
function THIDtestForm.GetFirstToken(S: string; Token: Char): string;
var
  Count: integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count < 1 then
  begin
    GetFirstToken := '';
    Exit;
  end;
  Dec(Count);
  Temp := Copy(S,1,Count);
  GetFirstToken := Temp;
end;

function THIDtestForm.StripFirstToken(S: string; Token: Char): string;
var
  Count: integer;
  Temp: string;
begin
  Count := Pos(Token, S);
  if Count = 0 then begin
    StripFirstToken := S;
    Exit;
  end;
  Temp := S;
  Delete(Temp,1,Count);
  StripFirstToken := Temp;
end;

function THIDtestForm.Int2StrPad0(N: LongInt; Len: Integer): string;
var
  S : string;
begin
  Str(N:0,S);
  while Length(S) < Len do
    S := '0' + S;
  Int2StrPad0 := S;
end;

function THIDtestForm.CleanString(S: string): string;
var
  Temp: string;
  i: integer;
  Ch: char;

begin

  for i := 1 to Length(S) do
  begin
    Ch := S[i];
    if Ch > chr(31) then
    begin
      Temp := Temp + Ch;
    end;
  end;
  CleanString := Temp;
end;
//******************************************************************************

procedure THIDtestForm.SendOut;
var
  Cnt: byte;
  NumBytes: byte;
  OK: boolean;
begin
  OK := TRUE;

  while (Length(SendStr) > 0) and OK do
  begin
    for Cnt := 0 to 63 do
      if (Cnt < Length(SendStr)) then
        Report.Data[Cnt] := ORD(SendStr[Cnt + 1])
      else
        Report.Data[Cnt] := 0;

    NumBytes := 0;
    NumBytes := HIDWriteDevice(Report);
    OK := NumBytes > 0;

    Delete(SendStr, 1, NumBytes);
    Application.ProcessMessages;
  end;
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.ScanForDevices;
var
  Info: THIDDeviceInfo;
  I: Byte;
  TmpS: string;
  VidStr: string;
  PidStr: string;
begin
  HIDcloseDevice;
  NumDevices := HIDscanForDevices;
  if (NumDevices > 0) then
  begin
    Memo1.Lines.Add(IntToStr(NumDevices) + ' device(s) found');

    for I := 0 to NumDevices - 1 do
    begin
      HIDGetDeviceInfo(I, Info);
      {ShowDevices(I, Info);}
      VidStr := IntToHex(Info.VID,4);
      PidStr := IntToHex(Info.PID,4);

      if ((VidStr = '1234') AND (PidStr = '0001')) then
      begin
        CurrentDevice := I;
        if HIDopenDevice(CurrentDevice) then
        begin
          TmpS := 'Device ID: '+IntToStr(I)+', '+Info.ManufacturerString
                  +', '+Info.ProductString+', VID:'+IntToHex(Info.VID,4)+', PID:'
                  +IntToHex(Info.PID,4);
          Memo1.Lines.Add(TmpS);
          Setup1.Enabled := true;
          WiFiPlus1.Enabled := true;
          Exit;
        end
        else
        begin
          Memo1.Lines.Add('Could not open device');
        end;
      end;
    end;
    Memo1.Lines.Add('Altair4 not found');
    Setup1.Enabled := false;
    WiFiPlus1.Enabled := false;
  end;
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.ShowDevices(Nr: Integer; Device: THIDdeviceInfo);
var
  I: byte;
  TmpS: string;
begin
  with Device do
  begin
    Memo1.Lines.Add('');
    Memo1.Lines.Add('------------------------------------------------');
    Memo1.Lines.Add('');

    Memo1.Lines.Add('Device Number       : ' + IntToStr(Nr));
    Memo1.Lines.Add('');
    TmpS := ManufacturerString + ' ' + ProductString + ' VID:' + IntToHex(VID, 4) + ' PID:' + IntToHex(PID, 4);

    if HasReadWriteAccess
      then TmpS := TmpS + ' R/W'
    else TmpS := TmpS + ' R/O';
    Memo1.Lines.Add(TmpS);

    Memo1.Lines.Add('');
    Memo1.Lines.Add('Output Buffer size  : ' + IntToStr(OutputBufferSize));
    Memo1.Lines.Add('Input Buffer size   : ' + IntToStr(InputBufferSize));
    Memo1.Lines.Add('Feature Buffer size : ' + IntToStr(FeatureBufferSize));

      // Display the output report's capabilities
    TmpS := '';
    for I := 0 to MaxNrCapabilities - 1 do
      if OutputReportCaps[I].ReportCount > 0 then
        TmpS :=
          TmpS + 'ReportId ' + IntToStr(OutputReportCaps[I].ReportId) {+ ', Usage ' + IntToStr(OutputReportCaps[I].Usage)} +
          ' (' + IntToStr(OutputReportCaps[I].ReportCount) + ' bytes); '; {' times ' + IntToStr(OutputReportCaps[I].ReportSize) + ' bits); ';}

    if TmpS = '' then TmpS := '0';
    TmpS := trim(TmpS);
    if TmpS[length(TmpS)] = ';' then delete(TmpS, length(TmpS), 1);
    Memo1.Lines.Add('Output Report(s)    : ' + TmpS);

      // Display the input report's capabilities
    TmpS := '';
    for I := 0 to MaxNrCapabilities - 1 do
      if InputReportCaps[I].ReportCount > 0 then
        TmpS := TmpS + 'ReportId ' + IntToStr(InputReportCaps[I].ReportId) {+ ', Usage ' + IntToStr(InputReportCaps[I].Usage)} +
          ' (' + IntToStr(InputReportCaps[I].ReportCount) + ' bytes); '; { times ' + IntToStr(InputReportCaps[I].ReportSize) + ' bits); '; }

    if TmpS = '' then TmpS := '0';
    TmpS := trim(TmpS);
    if TmpS[length(TmpS)] = ';' then delete(TmpS, length(TmpS), 1);
    Memo1.Lines.Add('Input Report(s)     : ' + TmpS);

      // Display the feature report's capabilities
    TmpS := '';
    for I := 0 to MaxNrCapabilities - 1 do
      if FeatureReportCaps[I].ReportCount > 0 then
        TmpS := TmpS + 'ReportId ' + IntToStr(FeatureReportCaps[I].ReportId) {+ ', Usage ' + IntToStr(FeatureReportCaps[I].Usage)} +
          ' (' + IntToStr(FeatureReportCaps[I].ReportCount) + ' bytes); '; { times ' + IntToStr(FeatureReportCaps[I].ReportSize) + ' bits); '; }

    if TmpS = '' then TmpS := '0';
    TmpS := trim(TmpS);
    if TmpS[length(TmpS)] = ';' then delete(TmpS, length(TmpS), 1);
    Memo1.Lines.Add('Feature Report(s)   : ' + TmpS);

  end;
end;

//------------------------------------------------------------------------------
// Callback procedure to capture incoming data.
// Data is put into a string for representation.
procedure HIDreader(Report: THIDReport; NumBytes: byte); stdcall;
var
  InStr: AnsiString;
  I: Integer;
begin
  InStr := '';
  for I := 0 to NumBytes - 1 do
    InStr := InStr + CHR(Report.Data[I]);

  HIDtestForm.Memo1.Lines.Add(InStr);
end;

//------------------------------------------------------------------------------
// Callback procedure for USB change event.
procedure CheckUSBevent; stdcall;
begin
  HIDtestForm.Memo1.Lines.Add('USB event');
  HIDtestForm.ScanForDevices;
  HIDtestForm.StatusBar1.Panels[0].Text := '';
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.FormCreate(Sender: TObject);
begin
  HIDsetEventHandler(@HIDreader); // Assign callback procedure for HID reader
  USBsetEventHandler(@CheckUSBevent); // Assign callback procedure for USB change event
  ScanForDevices;
  StatusBar1.Panels[0].Text := '';
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.Clear1Click(Sender: TObject);
begin
  Memo1.Clear;
  StatusBar1.Panels[0].Text := '';
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.SaveAs1Click(Sender: TObject);
var
  CurrentDir  : string;
  CurrentFile: string;
  SaveFile: TextFile;
begin
  GetDir(0,CurrentDir);
  SaveDialog1.InitialDir := CurrentDir;

  if SaveDialog1.Execute then
  begin
    CurrentFile := SaveDialog1.Filename;
    if Memo1.Lines.Count > 0 then
    begin
      AssignFile(SaveFile, CurrentFile);
      Memo1.Lines.SaveToFile(CurrentFile);
    end;
  end; {if SaveDialog1.Execute}
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.Exit1Click(Sender: TObject);
begin
  HIDCloseDevice;
  Close;
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.ShowDateTime1Click(Sender: TObject); // Display date/time
begin
  SendStr := 'a\r\n';
  SendOut;
  StatusBar1.Panels[0].Text := '';
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.SetDateTime1Click(Sender: TObject);  // Set date/time
var
  CurDate: TDateTime;
  WeekDay: integer;
  MyDate: string;
  DoW: string;
  Month: string;
  Day: string;
  Year: string;
  Time: string;
  Hour: string;
  Minute: string;
  Second: string;
begin
  CurDate := Date;
  WeekDay := DayOfWeek(CurDate);
  DoW := IntToStr(WeekDay);
  if (Length(DoW) < 2) then
    DoW := '0'+DoW;

  MyDate := FormatDateTime('yy/mm/dd', Now);
  Year := GetFirstToken(MyDate,'/');
  MyDate := StripFirstToken(MyDate,'/');
  Month := GetFirstToken(MyDate,'/');
  Day := StripFirstToken(MyDate,'/');

  Time := FormatDateTime('hh:nn:ss', Now);
  Hour := GetFirstToken(Time,':');
  Time := StripFirstToken(Time,':');
  Minute := GetFirstToken(Time,':');
  Second := StripFirstToken(Time,':');

  SendStr := 'b,'+Year+','+Month+','+Day+','+DoW+','+Hour+','+Minute+','+Second+CRLF;
  SendOut;
  StatusBar1.Panels[0].Text := 'Date/time set';
end;

//------------------------------------------------------------------------------
procedure THIDtestForm.Scan1Click(Sender: TObject);  // Scan for devices
begin
  ScanForDevices;
  StatusBar1.Panels[0].Text := '';
end;

procedure THIDtestForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  HIDCloseDevice;
  CanClose := true;
end;

procedure THIDtestForm.Button1Click(Sender: TObject);
begin
  if Edit1.Text <> '' then
  begin
     SendStr := Edit1.Text + CRLF;
     SendOut;
     StatusBar1.Panels[0].Text := 'Command sent';
  end
  else
  begin
     StatusBar1.Panels[0].Text := 'Enter command';
  end;
end;

procedure THIDtestForm.HwReset1Click(Sender: TObject);
begin
  SendStr := 'c'+CRLF;
  SendOut;
end;

procedure THIDtestForm.SwReset2Click(Sender: TObject);
begin
  SendStr := 'd'+CRLF;
  SendOut;
end;

procedure THIDtestForm.Ping1Click(Sender: TObject);
begin
  SendStr := 'e'+CRLF;
  SendOut;
end;

procedure THIDtestForm.GetVersion1Click(Sender: TObject);
begin
  SendStr := 'f'+CRLF;
  SendOut;
end;

procedure THIDtestForm.GetKey1Click(Sender: TObject);
begin
  SendStr := 'g'+CRLF;
  SendOut;
end;

procedure THIDtestForm.GetNetworkStatus1Click(Sender: TObject);
begin
  SendStr := 'z'+CRLF;
  SendOut;
end;

procedure THIDtestForm.ScanforAccessPoints1Click(Sender: TObject);
begin
  SendStr := 'y'+CRLF;
  SendOut;
end;

procedure THIDtestForm.SetWiFiParameters1Click(Sender: TObject);
begin
  SendStr := 'x'+CRLF;
  SendOut;
end;

procedure THIDtestForm.ConnecttoAccessPoint1Click(Sender: TObject);
begin
  SendStr := 'w'+CRLF;
  SendOut;
end;

procedure THIDtestForm.DisconnectfromAccessPoint1Click(Sender: TObject);
begin
  SendStr := 'v'+CRLF;
  SendOut;
end;

procedure THIDtestForm.CreateUDPsocket1Click(Sender: TObject);
begin
  SendStr := 'u'+CRLF;
  SendOut;
end;

procedure THIDtestForm.CloseSocket1Click(Sender: TObject);
begin
  SendStr := 't'+CRLF;
  SendOut;
end;

procedure THIDtestForm.BindSocket1Click(Sender: TObject);
begin
  SendStr := 's'+CRLF;
  SendOut;
end;

procedure THIDtestForm.ConnectSocket1Click(Sender: TObject);
begin
  SendStr := 'r'+CRLF;
  SendOut;
end;

procedure THIDtestForm.SendSocket1Click(Sender: TObject);
begin
  SendStr := 'o'+CRLF;
  SendOut;
end;

procedure THIDtestForm.SendToCommand1Click(Sender: TObject);
begin
  SendStr := 'm'+CRLF;
  SendOut;
end;

procedure THIDtestForm.ReceiveFromCommand1Click(Sender: TObject);
begin
  SendStr := 'l'+CRLF;
  SendOut;
end;

procedure THIDtestForm.DoUDPServer1Click(Sender: TObject);
begin
  SendStr := 'k'+CRLF;
  SendOut;
end;

initialization
  NumDevices := 0;
  CurrentDevice := -1;
  ProgDir := ExtractFilepath(Application.Exename);
  if ProgDir[Length(ProgDir)] <> '\'
    then ProgDir := ProgDir + '\';
  ChDir(ProgDir);
end.

