_Timer0A_interrupt:
;Timer0.c,17 :: 		void Timer0A_interrupt() iv IVT_INT_TIMER0A {
;Timer0.c,18 :: 		TIMER_ICR_TATOCINT_bit = 1;         // Clear time-out timer A interrupt
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TIMER_ICR_TATOCINT_bit+0)
MOVT	R0, #hi_addr(TIMER_ICR_TATOCINT_bit+0)
STR	R1, [R0, #0]
;Timer0.c,19 :: 		Epoch += 1;                         // Increment Date/Time by 1 second
MOVW	R1, #lo_addr(_Epoch+0)
MOVT	R1, #hi_addr(_Epoch+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;Timer0.c,20 :: 		TimerFlag = 1;                      // Set timer flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timer0.c,22 :: 		}
L_end_Timer0A_interrupt:
BX	LR
; end of _Timer0A_interrupt
_TimerInit:
;Timer0.c,25 :: 		void TimerInit() {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;Timer0.c,27 :: 		SYSCTL_RCGC1_TIMER0_bit = 1;        // Enable clock gating for timer module 0
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(SYSCTL_RCGC1_TIMER0_bit+0)
MOVT	R0, #hi_addr(SYSCTL_RCGC1_TIMER0_bit+0)
STR	R1, [R0, #0]
;Timer0.c,29 :: 		TIMER_CTL_TAEN_bit = 0;             // Disable timer
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TIMER_CTL_TAEN_bit+0)
MOVT	R0, #hi_addr(TIMER_CTL_TAEN_bit+0)
STR	R0, [SP, #4]
STR	R1, [R0, #0]
;Timer0.c,30 :: 		TIMER0_CFG = 0;                     // Set 32-bit timer configuration
MOVS	R1, #0
MOVW	R0, #lo_addr(TIMER0_CFG+0)
MOVT	R0, #hi_addr(TIMER0_CFG+0)
STR	R1, [R0, #0]
;Timer0.c,31 :: 		TIMER0_TAMR |= 2;                   // Set periodic mode
MOVW	R0, #lo_addr(TIMER0_TAMR+0)
MOVT	R0, #hi_addr(TIMER0_TAMR+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #2
MOVW	R0, #lo_addr(TIMER0_TAMR+0)
MOVT	R0, #hi_addr(TIMER0_TAMR+0)
STR	R1, [R0, #0]
;Timer0.c,32 :: 		TIMER0_TAILR = Get_Fosc_kHz()*1000; // Set interval load
BL	_Get_Fosc_kHz+0
MOVW	R1, #1000
MULS	R1, R0, R1
MOVW	R0, #lo_addr(TIMER0_TAILR+0)
MOVT	R0, #hi_addr(TIMER0_TAILR+0)
STR	R1, [R0, #0]
;Timer0.c,33 :: 		NVIC_IntEnable(IVT_INT_TIMER0A);    // Enable timer interrupt
MOVW	R0, #35
BL	_NVIC_IntEnable+0
;Timer0.c,34 :: 		TIMER_IMR_TATOIM_bit = 1;           // Enable time-out timer A interrupt
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TIMER_IMR_TATOIM_bit+0)
MOVT	R0, #hi_addr(TIMER_IMR_TATOIM_bit+0)
STR	R1, [R0, #0]
;Timer0.c,35 :: 		TIMER_CTL_TAEN_bit = 1;             // Enable timer A
LDR	R0, [SP, #4]
STR	R1, [R0, #0]
;Timer0.c,37 :: 		ts1.ss = 0;  // Cold Start values
MOVS	R1, #0
MOVW	R0, #lo_addr(_ts1+0)
MOVT	R0, #hi_addr(_ts1+0)
STRB	R1, [R0, #0]
;Timer0.c,38 :: 		ts1.mn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_ts1+1)
MOVT	R0, #hi_addr(_ts1+1)
STRB	R1, [R0, #0]
;Timer0.c,39 :: 		ts1.hh = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_ts1+2)
MOVT	R0, #hi_addr(_ts1+2)
STRB	R1, [R0, #0]
;Timer0.c,40 :: 		ts1.md = 28;
MOVS	R1, #28
MOVW	R0, #lo_addr(_ts1+3)
MOVT	R0, #hi_addr(_ts1+3)
STRB	R1, [R0, #0]
;Timer0.c,41 :: 		ts1.wd = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_ts1+4)
MOVT	R0, #hi_addr(_ts1+4)
STRB	R1, [R0, #0]
;Timer0.c,42 :: 		ts1.mo = 6;
MOVS	R1, #6
MOVW	R0, #lo_addr(_ts1+5)
MOVT	R0, #hi_addr(_ts1+5)
STRB	R1, [R0, #0]
;Timer0.c,43 :: 		ts1.yy = 2012;
MOVW	R1, #2012
MOVW	R0, #lo_addr(_ts1+6)
MOVT	R0, #hi_addr(_ts1+6)
STRH	R1, [R0, #0]
;Timer0.c,45 :: 		Epoch = Time_dateToEpoch(&ts1);
MOVW	R0, #lo_addr(_ts1+0)
MOVT	R0, #hi_addr(_ts1+0)
BL	_Time_dateToEpoch+0
MOVW	R1, #lo_addr(_Epoch+0)
MOVT	R1, #hi_addr(_Epoch+0)
STR	R0, [R1, #0]
;Timer0.c,46 :: 		}
L_end_TimerInit:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _TimerInit
_TimerCheck:
;Timer0.c,49 :: 		void TimerCheck() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timer0.c,50 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck0
;Timer0.c,51 :: 		TimerFlag = 0;  // Reset timer flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timer0.c,52 :: 		Time_epochToDate(Epoch, &ts1);
MOVW	R0, #lo_addr(_Epoch+0)
MOVT	R0, #hi_addr(_Epoch+0)
LDR	R0, [R0, #0]
MOVW	R1, #lo_addr(_ts1+0)
MOVT	R1, #hi_addr(_ts1+0)
BL	_Time_epochToDate+0
;Timer0.c,54 :: 		irqhandler_timer();  // Last function in this module
BL	_irqhandler_timer+0
;Timer0.c,64 :: 		}
L_TimerCheck0:
;Timer0.c,65 :: 		}
L_end_TimerCheck:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TimerCheck
_init_timerpool:
;Timer0.c,91 :: 		void init_timerpool(void) {
;Timer0.c,94 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_init_timerpool1:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_init_timerpool2
;Timer0.c,95 :: 		TimerPool[i].TimerField = 0;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STR	R0, [R1, #0]
;Timer0.c,96 :: 		TimerPool[i].Free = TRUE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timer0.c,94 :: 		for (i=0; i < NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timer0.c,97 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_timerpool1
L_init_timerpool2:
;Timer0.c,98 :: 		}
L_end_init_timerpool:
BX	LR
; end of _init_timerpool
_get_timer:
;Timer0.c,106 :: 		unsigned short int get_timer(void) {
;Timer0.c,110 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_get_timer4:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_get_timer5
;Timer0.c,111 :: 		if (TimerPool[i].Free == TRUE) {
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer7
;Timer0.c,114 :: 		TimerPool[i].Free = FALSE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;Timer0.c,117 :: 		return i;
UXTB	R0, R2
; i end address is: 8 (R2)
IT	AL
BAL	L_end_get_timer
;Timer0.c,118 :: 		}
L_get_timer7:
;Timer0.c,110 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
ADDS	R2, R2, #1
UXTB	R2, R2
;Timer0.c,119 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_get_timer4
L_get_timer5:
;Timer0.c,124 :: 		return (0);
MOVS	R0, #0
;Timer0.c,125 :: 		}
L_end_get_timer:
BX	LR
; end of _get_timer
_free_timer:
;Timer0.c,133 :: 		void free_timer(unsigned short int nbr) {
;Timer0.c,135 :: 		if (nbr > (NUMTIMERS-1))
CMP	R0, #9
IT	LS
BLS	L_free_timer8
;Timer0.c,136 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer8:
;Timer0.c,138 :: 		TimerPool[nbr].Free = TRUE;
LSLS	R2, R0, #3
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
ADDS	R2, R1, #4
MOVS	R1, #1
STRB	R1, [R2, #0]
;Timer0.c,139 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;Timer0.c,148 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
; tout start address is: 4 (R1)
; tout end address is: 4 (R1)
; tout start address is: 4 (R1)
;Timer0.c,152 :: 		if (nbr > (NUMTIMERS-1))
CMP	R0, #9
IT	LS
BLS	L_set_timer9
; tout end address is: 4 (R1)
;Timer0.c,153 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer9:
;Timer0.c,155 :: 		if (TimerPool[nbr].Free == TRUE)
; tout start address is: 4 (R1)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
ADDS	R2, R2, #4
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_set_timer10
; tout end address is: 4 (R1)
;Timer0.c,156 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer10:
;Timer0.c,163 :: 		TimerPool[nbr].TimerField = tout;
; tout start address is: 4 (R1)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
STR	R1, [R2, #0]
; tout end address is: 4 (R1)
;Timer0.c,164 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;Timer0.c,172 :: 		unsigned long int check_timer(unsigned short int nbr) {
;Timer0.c,173 :: 		return TimerPool[nbr].TimerField;
LSLS	R2, R0, #3
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
LDR	R1, [R1, #0]
MOV	R0, R1
;Timer0.c,174 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;Timer0.c,182 :: 		void irqhandler_timer(void) {
;Timer0.c,185 :: 		for (i=0; i<NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_irqhandler_timer11:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_irqhandler_timer12
;Timer0.c,186 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__irqhandler_timer19
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__irqhandler_timer18
L__irqhandler_timer17:
;Timer0.c,187 :: 		TimerPool[i].TimerField--;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;Timer0.c,186 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer19:
L__irqhandler_timer18:
;Timer0.c,185 :: 		for (i=0; i<NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timer0.c,188 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_irqhandler_timer11
L_irqhandler_timer12:
;Timer0.c,189 :: 		}
L_end_irqhandler_timer:
BX	LR
; end of _irqhandler_timer
