/**************************************************************************************************
  UART0.h
  Custom UART driver for the Microchip MCW1001A chip.
**************************************************************************************************/
#ifndef UART0_H
#define UART0_H


// Defines
#define DC3 0x13         // XOFF control character
#define DC1 0x11         // XON control character
#define NUL 0x00         // NUL control character

#define RcvBufSize 1536  // Number of bytes in Receive Buffer
#define rxqsize 256      // Number of characters in receive buffer queue
#define txqsize 64       // Number of pointers in transmit queue



typedef void (*tPointerFcn)(void);  // Pointer to a function




// Function Prototypes
void UART0Init(void);
void UART0_Initialize(void);
void UART0_RxQueueInit(void);
void UART0_Receive_Char(void);
char UART0_GetChar(char *rxbyte);

void UART0_Rx(void);
void UART0_Rx1(void);
void UART0_Rx2(void);


void UART0_TxQueueInit(void);
void UART0_PutQueue(char *msg, unsigned int msgsize);

void UART0_Tx(void);
void UART0_Tx1(void);
void UART0_Tx2(void);





#endif