#include "WiFiTEst_objects.h"
#include "WiFiTEst_resources.h"
#include "built_in.h"


// TFT module connections
char TFT_DataPort at GPIO_PORTJ_DATA;
sbit TFT_RST at GPIO_PORTH_DATA.B5;
sbit TFT_BLED at GPIO_PORTD_DATA.B3;
sbit TFT_RS at GPIO_PORTG_DATA.B7;
sbit TFT_CS at GPIO_PORTH_DATA.B6;
sbit TFT_RD at GPIO_PORTA_DATA.B6;
sbit TFT_WR at GPIO_PORTA_DATA.B7;
char TFT_DataPort_Direction at GPIO_PORTJ_DIR;
sbit TFT_RST_Direction at GPIO_PORTH_DIR.B5;
sbit TFT_BLED_Direction at GPIO_PORTD_DIR.B3;
sbit TFT_RS_Direction at GPIO_PORTG_DIR.B7;
sbit TFT_CS_Direction at GPIO_PORTH_DIR.B6;
sbit TFT_RD_Direction at GPIO_PORTA_DIR.B6;
sbit TFT_WR_Direction at GPIO_PORTA_DIR.B7;
// End TFT module connections

// Touch Panel module connections
sbit Drivex_Left at GPIO_PORTB_DATA.B4;
sbit Drivex_Right at GPIO_PORTE_DATA.B0;
sbit Drivey_Up at GPIO_PORTE_DATA.B1;
sbit Drivey_Down at GPIO_PORTB_DATA.B5;
sbit Drivex_Left_Direction at GPIO_PORTB_DIR.B4;
sbit Drivex_Right_Direction at GPIO_PORTE_DIR.B0;
sbit Drivey_Up_Direction at GPIO_PORTE_DIR.B1;
sbit Drivey_Down_Direction at GPIO_PORTB_DIR.B5;
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
const ADC_THRESHOLD = 750;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;
TBox *local_box;
TBox *exec_box;
int box_order;
TBox_Round *local_round_box;
TBox_Round *exec_round_box;
int box_round_order;


void Init_ADC() {
  ADC_Set_Input_Channel(_ADC_CHANNEL_10 | _ADC_CHANNEL_11);
  ADC0_Init_Advanced(_ADC_EXTERNAL_REF);
}
static void InitializeTouchPanel() {
  Init_ADC();
  TFT_Init(320, 240);

  TP_TFT_Init(320, 240, 11, 10);                                  // Initialize touch panel
  TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen1;
  TImage               Image1;
  TBox                   Box1;
  TLabel                 Label1;
char Label1_Caption[5] = "SSID";

  TLabel                 Label2;
char Label2_Caption[7] = "Config";

  TLabel                 Label3;
char Label3_Caption[5] = "Chan";

  TLine                  Line1;
  TLabel                 Label5;
char Label5_Caption[7] = "---";

  TLabel                 Label6;
char Label6_Caption[4] = "---";

  TLabel                 Label7;
char Label7_Caption[21] = "---";

  TLabel                 Label8;
char Label8_Caption[7] = "---";

  TLabel                 Label9;
char Label9_Caption[4] = "---";

  TLabel                 Label10;
char Label10_Caption[21] = "---";

  TLabel                 Label11;
char Label11_Caption[7] = "---";

  TLabel                 Label12;
char Label12_Caption[4] = "---";

  TLabel                 Label13;
char Label13_Caption[21] = "---";

  TLabel                 Label14;
char Label14_Caption[7] = "---";

  TLabel                 Label15;
char Label15_Caption[4] = "---";

  TLabel                 Label16;
char Label16_Caption[21] = "---";

  TLabel                 Label17;
char Label17_Caption[7] = "---";

  TLabel                 Label18;
char Label18_Caption[4] = "---";

  TLabel                 Label4;
char Label4_Caption[21] = "---";

  TLabel                 Label19;
char Label19_Caption[41] = " ";

  TButton_Round          ButtonRound1;
char ButtonRound1_Caption[5] = "Scan";

  TButton_Round          ButtonRound2;
char ButtonRound2_Caption[8] = "Connect";

  TButton_Round          ButtonRound3;
char ButtonRound3_Caption[10] = "Start UDP";

  TButton_Round          ButtonRound4;
char ButtonRound4_Caption[11] = "Disconnect";

  TButton_Round          * const code Screen1_Buttons_Round[4]=
         {
         &ButtonRound1,        
         &ButtonRound2,        
         &ButtonRound3,        
         &ButtonRound4         
         };
  TLabel                 * const code Screen1_Labels[19]=
         {
         &Label1,              
         &Label2,              
         &Label3,              
         &Label5,              
         &Label6,              
         &Label7,              
         &Label8,              
         &Label9,              
         &Label10,             
         &Label11,             
         &Label12,             
         &Label13,             
         &Label14,             
         &Label15,             
         &Label16,             
         &Label17,             
         &Label18,             
         &Label4,              
         &Label19              
         };
  TImage                 * const code Screen1_Images[1]=
         {
         &Image1               
         };
  TBox                   * const code Screen1_Boxes[1]=
         {
         &Box1                 
         };
  TLine                  * const code Screen1_Lines[1]=
         {
         &Line1                
         };


  TScreen                Screen2;
  TBox_Round             Qwerty_BoxRound1;
  TButton_Round          Qwerty_ButtonRound1;
char Qwerty_ButtonRound1_Caption[2] = "1";

  TButton_Round          Qwerty_ButtonRound2;
char Qwerty_ButtonRound2_Caption[2] = "2";

  TButton_Round          Qwerty_ButtonRound3;
char Qwerty_ButtonRound3_Caption[2] = "3";

  TButton_Round          Qwerty_ButtonRound4;
char Qwerty_ButtonRound4_Caption[2] = "4";

  TButton_Round          Qwerty_ButtonRound5;
char Qwerty_ButtonRound5_Caption[2] = "5";

  TButton_Round          Qwerty_ButtonRound6;
char Qwerty_ButtonRound6_Caption[2] = "6";

  TButton_Round          Qwerty_ButtonRound7;
char Qwerty_ButtonRound7_Caption[2] = "7";

  TButton_Round          Qwerty_ButtonRound8;
char Qwerty_ButtonRound8_Caption[2] = "8";

  TButton_Round          Qwerty_ButtonRound9;
char Qwerty_ButtonRound9_Caption[2] = "9";

  TButton_Round          Qwerty_ButtonRound10;
char Qwerty_ButtonRound10_Caption[2] = "0";

  TButton_Round          Qwerty_ButtonRound11;
char Qwerty_ButtonRound11_Caption[2] = "Q";

  TButton_Round          Qwerty_ButtonRound12;
char Qwerty_ButtonRound12_Caption[2] = "W";

  TButton_Round          Qwerty_ButtonRound13;
char Qwerty_ButtonRound13_Caption[2] = "E";

  TButton_Round          Qwerty_ButtonRound14;
char Qwerty_ButtonRound14_Caption[2] = "R";

  TButton_Round          Qwerty_ButtonRound15;
char Qwerty_ButtonRound15_Caption[2] = "T";

  TButton_Round          Qwerty_ButtonRound16;
char Qwerty_ButtonRound16_Caption[2] = "Y";

  TButton_Round          Qwerty_ButtonRound17;
char Qwerty_ButtonRound17_Caption[2] = "U";

  TButton_Round          Qwerty_ButtonRound18;
char Qwerty_ButtonRound18_Caption[2] = "I";

  TButton_Round          Qwerty_ButtonRound19;
char Qwerty_ButtonRound19_Caption[2] = "O";

  TButton_Round          Qwerty_ButtonRound20;
char Qwerty_ButtonRound20_Caption[2] = "P";

  TButton_Round          Qwerty_ButtonRound21;
char Qwerty_ButtonRound21_Caption[2] = "A";

  TButton_Round          Qwerty_ButtonRound22;
char Qwerty_ButtonRound22_Caption[2] = "S";

  TButton_Round          Qwerty_ButtonRound23;
char Qwerty_ButtonRound23_Caption[2] = "D";

  TButton_Round          Qwerty_ButtonRound24;
char Qwerty_ButtonRound24_Caption[2] = "F";

  TButton_Round          Qwerty_ButtonRound25;
char Qwerty_ButtonRound25_Caption[2] = "G";

  TButton_Round          Qwerty_ButtonRound26;
char Qwerty_ButtonRound26_Caption[2] = "H";

  TButton_Round          Qwerty_ButtonRound27;
char Qwerty_ButtonRound27_Caption[2] = "J";

  TButton_Round          Qwerty_ButtonRound28;
char Qwerty_ButtonRound28_Caption[2] = "K";

  TButton_Round          Qwerty_ButtonRound29;
char Qwerty_ButtonRound29_Caption[2] = "L";

  TButton_Round          Qwerty_ButtonRound30;
char Qwerty_ButtonRound30_Caption[2] = ":";

  TButton_Round          Qwerty_ButtonRound31;
char Qwerty_ButtonRound31_Caption[2] = "Z";

  TButton_Round          Qwerty_ButtonRound32;
char Qwerty_ButtonRound32_Caption[2] = "X";

  TButton_Round          Qwerty_ButtonRound33;
char Qwerty_ButtonRound33_Caption[2] = "C";

  TButton_Round          Qwerty_ButtonRound34;
char Qwerty_ButtonRound34_Caption[2] = "V";

  TButton_Round          Qwerty_ButtonRound35;
char Qwerty_ButtonRound35_Caption[2] = "B";

  TButton_Round          Qwerty_ButtonRound36;
char Qwerty_ButtonRound36_Caption[2] = "N";

  TButton_Round          Qwerty_ButtonRound37;
char Qwerty_ButtonRound37_Caption[2] = "M";

  TButton_Round          Qwerty_ButtonRound38;
char Qwerty_ButtonRound38_Caption[2] = ",";

  TButton_Round          Qwerty_ButtonRound39;
char Qwerty_ButtonRound39_Caption[2] = ".";

  TButton_Round          Qwerty_ButtonRound40;
char Qwerty_ButtonRound40_Caption[2] = "/";

  TButton_Round          Qwerty_ButtonRound41;
char Qwerty_ButtonRound41_Caption[6] = "Shift";

  TButton_Round          Qwerty_ButtonRound42;
char Qwerty_ButtonRound42_Caption[6] = "Space";

  TButton_Round          Qwerty_ButtonRound43;
char Qwerty_ButtonRound43_Caption[8] = "BkSpace";

  TButton_Round          Qwerty_ButtonRound44;
char Qwerty_ButtonRound44_Caption[7] = "Return";

  TLabel                 Qwerty_Label1;
char Qwerty_Label1_Caption[65] = " ";

  TLabel                 Qwerty_Label2;
char Qwerty_Label2_Caption[15] = "Enter password";

  TButton_Round          * const code Screen2_Buttons_Round[44]=
         {
         &Qwerty_ButtonRound1, 
         &Qwerty_ButtonRound2, 
         &Qwerty_ButtonRound3, 
         &Qwerty_ButtonRound4, 
         &Qwerty_ButtonRound5, 
         &Qwerty_ButtonRound6, 
         &Qwerty_ButtonRound7, 
         &Qwerty_ButtonRound8, 
         &Qwerty_ButtonRound9, 
         &Qwerty_ButtonRound10,
         &Qwerty_ButtonRound11,
         &Qwerty_ButtonRound12,
         &Qwerty_ButtonRound13,
         &Qwerty_ButtonRound14,
         &Qwerty_ButtonRound15,
         &Qwerty_ButtonRound16,
         &Qwerty_ButtonRound17,
         &Qwerty_ButtonRound18,
         &Qwerty_ButtonRound19,
         &Qwerty_ButtonRound20,
         &Qwerty_ButtonRound21,
         &Qwerty_ButtonRound22,
         &Qwerty_ButtonRound23,
         &Qwerty_ButtonRound24,
         &Qwerty_ButtonRound25,
         &Qwerty_ButtonRound26,
         &Qwerty_ButtonRound27,
         &Qwerty_ButtonRound28,
         &Qwerty_ButtonRound29,
         &Qwerty_ButtonRound30,
         &Qwerty_ButtonRound31,
         &Qwerty_ButtonRound32,
         &Qwerty_ButtonRound33,
         &Qwerty_ButtonRound34,
         &Qwerty_ButtonRound35,
         &Qwerty_ButtonRound36,
         &Qwerty_ButtonRound37,
         &Qwerty_ButtonRound38,
         &Qwerty_ButtonRound39,
         &Qwerty_ButtonRound40,
         &Qwerty_ButtonRound41,
         &Qwerty_ButtonRound42,
         &Qwerty_ButtonRound43,
         &Qwerty_ButtonRound44 
         };
  TLabel                 * const code Screen2_Labels[2]=
         {
         &Qwerty_Label1,       
         &Qwerty_Label2        
         };
  TBox_Round             * const code Screen2_Boxes_Round[1]=
         {
         &Qwerty_BoxRound1     
         };




static void InitializeObjects() {
  Screen1.Color                     = 0x0410;
  Screen1.Width                     = 320;
  Screen1.Height                    = 240;
  Screen1.Buttons_RoundCount        = 4;
  Screen1.Buttons_Round             = Screen1_Buttons_Round;
  Screen1.LabelsCount               = 19;
  Screen1.Labels                    = Screen1_Labels;
  Screen1.ImagesCount               = 1;
  Screen1.Images                    = Screen1_Images;
  Screen1.BoxesCount                = 1;
  Screen1.Boxes                     = Screen1_Boxes;
  Screen1.Boxes_RoundCount          = 0;
  Screen1.LinesCount                = 1;
  Screen1.Lines                     = Screen1_Lines;
  Screen1.ObjectsCount              = 26;

  Screen2.Color                     = 0x87FF;
  Screen2.Width                     = 320;
  Screen2.Height                    = 240;
  Screen2.Buttons_RoundCount        = 44;
  Screen2.Buttons_Round             = Screen2_Buttons_Round;
  Screen2.LabelsCount               = 2;
  Screen2.Labels                    = Screen2_Labels;
  Screen2.ImagesCount               = 0;
  Screen2.BoxesCount                = 0;
  Screen2.Boxes_RoundCount          = 1;
  Screen2.Boxes_Round               = Screen2_Boxes_Round;
  Screen2.LinesCount                = 0;
  Screen2.ObjectsCount              = 47;


  Image1.OwnerScreen     = &Screen1;
  Image1.Order           = 0;
  Image1.Left            = 265;
  Image1.Top             = 4;
  Image1.Width           = 48;
  Image1.Height          = 48;
  Image1.Picture_Type    = 0;
  Image1.Picture_Ratio   = 1;
  Image1.Picture_Name    = wireless_bmp;
  Image1.Visible         = 1;
  Image1.Active          = 1;
  Image1.OnUpPtr         = 0;
  Image1.OnDownPtr       = 0;
  Image1.OnClickPtr      = 0;
  Image1.OnPressPtr      = 0;

  Box1.OwnerScreen     = &Screen1;
  Box1.Order           = 1;
  Box1.Left            = 4;
  Box1.Top             = 4;
  Box1.Width           = 248;
  Box1.Height          = 232;
  Box1.Pen_Width       = 1;
  Box1.Pen_Color       = 0x0000;
  Box1.Visible         = 1;
  Box1.Active          = 0;
  Box1.Transparent     = 1;
  Box1.Gradient        = 0;
  Box1.Gradient_Orientation    = 0;
  Box1.Gradient_Start_Color    = 0xFFFF;
  Box1.Gradient_End_Color      = 0xFFFF;
  Box1.Color           = 0xFFFF;
  Box1.PressColEnabled     = 1;
  Box1.Press_Color     = 0xE71C;
  Box1.OnUpPtr         = 0;
  Box1.OnDownPtr       = 0;
  Box1.OnClickPtr      = 0;
  Box1.OnPressPtr      = 0;

  Label1.OwnerScreen     = &Screen1;
  Label1.Order           = 2;
  Label1.Left            = 22;
  Label1.Top             = 14;
  Label1.Width           = 28;
  Label1.Height          = 15;
  Label1.Visible         = 1;
  Label1.Active          = 1;
  Label1.Caption         = Label1_Caption;
  Label1.FontName        = Tahoma13x13_Bold;
  Label1.Font_Color      = 0x0000;
  Label1.OnUpPtr         = 0;
  Label1.OnDownPtr       = 0;
  Label1.OnClickPtr      = 0;
  Label1.OnPressPtr      = 0;

  Label2.OwnerScreen     = &Screen1;
  Label2.Order           = 3;
  Label2.Left            = 155;
  Label2.Top             = 14;
  Label2.Width           = 37;
  Label2.Height          = 15;
  Label2.Visible         = 1;
  Label2.Active          = 1;
  Label2.Caption         = Label2_Caption;
  Label2.FontName        = Tahoma13x13_Bold;
  Label2.Font_Color      = 0x0000;
  Label2.OnUpPtr         = 0;
  Label2.OnDownPtr       = 0;
  Label2.OnClickPtr      = 0;
  Label2.OnPressPtr      = 0;

  Label3.OwnerScreen     = &Screen1;
  Label3.Order           = 4;
  Label3.Left            = 208;
  Label3.Top             = 14;
  Label3.Width           = 29;
  Label3.Height          = 15;
  Label3.Visible         = 1;
  Label3.Active          = 1;
  Label3.Caption         = Label3_Caption;
  Label3.FontName        = Tahoma13x13_Bold;
  Label3.Font_Color      = 0x0000;
  Label3.OnUpPtr         = 0;
  Label3.OnDownPtr       = 0;
  Label3.OnClickPtr      = 0;
  Label3.OnPressPtr      = 0;

  Line1.OwnerScreen     = &Screen1;
  Line1.Order           = 5;
  Line1.First_Point_X   = 14;
  Line1.First_Point_Y   = 29;
  Line1.Second_Point_X  = 244;
  Line1.Second_Point_Y  = 29;
  Line1.Visible         = 1;
  Line1.Pen_Width       = 1;
  Line1.Color           = 0x0000;

  Label5.OwnerScreen     = &Screen1;
  Label5.Order           = 6;
  Label5.Left            = 155;
  Label5.Top             = 36;
  Label5.Width           = 15;
  Label5.Height          = 15;
  Label5.Visible         = 1;
  Label5.Active          = 1;
  Label5.Caption         = Label5_Caption;
  Label5.FontName        = Tahoma13x13_Bold;
  Label5.Font_Color      = 0x0000;
  Label5.OnUpPtr         = 0;
  Label5.OnDownPtr       = 0;
  Label5.OnClickPtr      = 0;
  Label5.OnPressPtr      = 0;

  Label6.OwnerScreen     = &Screen1;
  Label6.Order           = 7;
  Label6.Left            = 214;
  Label6.Top             = 36;
  Label6.Width           = 15;
  Label6.Height          = 15;
  Label6.Visible         = 1;
  Label6.Active          = 1;
  Label6.Caption         = Label6_Caption;
  Label6.FontName        = Tahoma13x13_Bold;
  Label6.Font_Color      = 0x0000;
  Label6.OnUpPtr         = 0;
  Label6.OnDownPtr       = 0;
  Label6.OnClickPtr      = 0;
  Label6.OnPressPtr      = 0;

  Label7.OwnerScreen     = &Screen1;
  Label7.Order           = 8;
  Label7.Left            = 22;
  Label7.Top             = 58;
  Label7.Width           = 15;
  Label7.Height          = 15;
  Label7.Visible         = 1;
  Label7.Active          = 1;
  Label7.Caption         = Label7_Caption;
  Label7.FontName        = Tahoma13x13_Bold;
  Label7.Font_Color      = 0x0000;
  Label7.OnUpPtr         = 0;
  Label7.OnDownPtr       = 0;
  Label7.OnClickPtr      = Label7OnClick;
  Label7.OnPressPtr      = 0;

  Label8.OwnerScreen     = &Screen1;
  Label8.Order           = 9;
  Label8.Left            = 155;
  Label8.Top             = 58;
  Label8.Width           = 15;
  Label8.Height          = 15;
  Label8.Visible         = 1;
  Label8.Active          = 1;
  Label8.Caption         = Label8_Caption;
  Label8.FontName        = Tahoma13x13_Bold;
  Label8.Font_Color      = 0x0000;
  Label8.OnUpPtr         = 0;
  Label8.OnDownPtr       = 0;
  Label8.OnClickPtr      = 0;
  Label8.OnPressPtr      = 0;

  Label9.OwnerScreen     = &Screen1;
  Label9.Order           = 10;
  Label9.Left            = 214;
  Label9.Top             = 58;
  Label9.Width           = 15;
  Label9.Height          = 15;
  Label9.Visible         = 1;
  Label9.Active          = 1;
  Label9.Caption         = Label9_Caption;
  Label9.FontName        = Tahoma13x13_Bold;
  Label9.Font_Color      = 0x0000;
  Label9.OnUpPtr         = 0;
  Label9.OnDownPtr       = 0;
  Label9.OnClickPtr      = 0;
  Label9.OnPressPtr      = 0;

  Label10.OwnerScreen     = &Screen1;
  Label10.Order           = 11;
  Label10.Left            = 22;
  Label10.Top             = 80;
  Label10.Width           = 15;
  Label10.Height          = 15;
  Label10.Visible         = 1;
  Label10.Active          = 1;
  Label10.Caption         = Label10_Caption;
  Label10.FontName        = Tahoma13x13_Bold;
  Label10.Font_Color      = 0x0000;
  Label10.OnUpPtr         = 0;
  Label10.OnDownPtr       = 0;
  Label10.OnClickPtr      = Label10OnClick;
  Label10.OnPressPtr      = 0;

  Label11.OwnerScreen     = &Screen1;
  Label11.Order           = 12;
  Label11.Left            = 155;
  Label11.Top             = 80;
  Label11.Width           = 15;
  Label11.Height          = 15;
  Label11.Visible         = 1;
  Label11.Active          = 1;
  Label11.Caption         = Label11_Caption;
  Label11.FontName        = Tahoma13x13_Bold;
  Label11.Font_Color      = 0x0000;
  Label11.OnUpPtr         = 0;
  Label11.OnDownPtr       = 0;
  Label11.OnClickPtr      = 0;
  Label11.OnPressPtr      = 0;

  Label12.OwnerScreen     = &Screen1;
  Label12.Order           = 13;
  Label12.Left            = 214;
  Label12.Top             = 80;
  Label12.Width           = 15;
  Label12.Height          = 15;
  Label12.Visible         = 1;
  Label12.Active          = 1;
  Label12.Caption         = Label12_Caption;
  Label12.FontName        = Tahoma13x13_Bold;
  Label12.Font_Color      = 0x0000;
  Label12.OnUpPtr         = 0;
  Label12.OnDownPtr       = 0;
  Label12.OnClickPtr      = 0;
  Label12.OnPressPtr      = 0;

  Label13.OwnerScreen     = &Screen1;
  Label13.Order           = 14;
  Label13.Left            = 22;
  Label13.Top             = 102;
  Label13.Width           = 15;
  Label13.Height          = 15;
  Label13.Visible         = 1;
  Label13.Active          = 1;
  Label13.Caption         = Label13_Caption;
  Label13.FontName        = Tahoma13x13_Bold;
  Label13.Font_Color      = 0x0000;
  Label13.OnUpPtr         = 0;
  Label13.OnDownPtr       = 0;
  Label13.OnClickPtr      = Label13OnClick;
  Label13.OnPressPtr      = 0;

  Label14.OwnerScreen     = &Screen1;
  Label14.Order           = 15;
  Label14.Left            = 155;
  Label14.Top             = 102;
  Label14.Width           = 15;
  Label14.Height          = 15;
  Label14.Visible         = 1;
  Label14.Active          = 1;
  Label14.Caption         = Label14_Caption;
  Label14.FontName        = Tahoma13x13_Bold;
  Label14.Font_Color      = 0x0000;
  Label14.OnUpPtr         = 0;
  Label14.OnDownPtr       = 0;
  Label14.OnClickPtr      = 0;
  Label14.OnPressPtr      = 0;

  Label15.OwnerScreen     = &Screen1;
  Label15.Order           = 16;
  Label15.Left            = 214;
  Label15.Top             = 102;
  Label15.Width           = 15;
  Label15.Height          = 15;
  Label15.Visible         = 1;
  Label15.Active          = 1;
  Label15.Caption         = Label15_Caption;
  Label15.FontName        = Tahoma13x13_Bold;
  Label15.Font_Color      = 0x0000;
  Label15.OnUpPtr         = 0;
  Label15.OnDownPtr       = 0;
  Label15.OnClickPtr      = 0;
  Label15.OnPressPtr      = 0;

  Label16.OwnerScreen     = &Screen1;
  Label16.Order           = 17;
  Label16.Left            = 22;
  Label16.Top             = 124;
  Label16.Width           = 15;
  Label16.Height          = 15;
  Label16.Visible         = 1;
  Label16.Active          = 1;
  Label16.Caption         = Label16_Caption;
  Label16.FontName        = Tahoma13x13_Bold;
  Label16.Font_Color      = 0x0000;
  Label16.OnUpPtr         = 0;
  Label16.OnDownPtr       = 0;
  Label16.OnClickPtr      = Label16OnClick;
  Label16.OnPressPtr      = 0;

  Label17.OwnerScreen     = &Screen1;
  Label17.Order           = 18;
  Label17.Left            = 155;
  Label17.Top             = 124;
  Label17.Width           = 15;
  Label17.Height          = 15;
  Label17.Visible         = 1;
  Label17.Active          = 1;
  Label17.Caption         = Label17_Caption;
  Label17.FontName        = Tahoma13x13_Bold;
  Label17.Font_Color      = 0x0000;
  Label17.OnUpPtr         = 0;
  Label17.OnDownPtr       = 0;
  Label17.OnClickPtr      = 0;
  Label17.OnPressPtr      = 0;

  Label18.OwnerScreen     = &Screen1;
  Label18.Order           = 19;
  Label18.Left            = 214;
  Label18.Top             = 124;
  Label18.Width           = 15;
  Label18.Height          = 15;
  Label18.Visible         = 1;
  Label18.Active          = 1;
  Label18.Caption         = Label18_Caption;
  Label18.FontName        = Tahoma13x13_Bold;
  Label18.Font_Color      = 0x0000;
  Label18.OnUpPtr         = 0;
  Label18.OnDownPtr       = 0;
  Label18.OnClickPtr      = 0;
  Label18.OnPressPtr      = 0;

  Label4.OwnerScreen     = &Screen1;
  Label4.Order           = 20;
  Label4.Left            = 22;
  Label4.Top             = 36;
  Label4.Width           = 15;
  Label4.Height          = 15;
  Label4.Visible         = 1;
  Label4.Active          = 1;
  Label4.Caption         = Label4_Caption;
  Label4.FontName        = Tahoma13x13_Bold;
  Label4.Font_Color      = 0x0000;
  Label4.OnUpPtr         = 0;
  Label4.OnDownPtr       = 0;
  Label4.OnClickPtr      = Label4OnClick;
  Label4.OnPressPtr      = 0;

  Label19.OwnerScreen     = &Screen1;
  Label19.Order           = 21;
  Label19.Left            = 22;
  Label19.Top             = 204;
  Label19.Width           = 0;
  Label19.Height          = 15;
  Label19.Visible         = 1;
  Label19.Active          = 1;
  Label19.Caption         = Label19_Caption;
  Label19.FontName        = Tahoma13x13_Bold;
  Label19.Font_Color      = 0xF800;
  Label19.OnUpPtr         = 0;
  Label19.OnDownPtr       = 0;
  Label19.OnClickPtr      = 0;
  Label19.OnPressPtr      = 0;

  ButtonRound1.OwnerScreen     = &Screen1;
  ButtonRound1.Order           = 22;
  ButtonRound1.Left            = 257;
  ButtonRound1.Top             = 67;
  ButtonRound1.Width           = 60;
  ButtonRound1.Height          = 25;
  ButtonRound1.Pen_Width       = 1;
  ButtonRound1.Pen_Color       = 0x0000;
  ButtonRound1.Visible         = 1;
  ButtonRound1.Active          = 1;
  ButtonRound1.Transparent     = 1;
  ButtonRound1.Caption         = ButtonRound1_Caption;
  ButtonRound1.TextAlign       = _taCenter;
  ButtonRound1.FontName        = Tahoma11x13_Regular;
  ButtonRound1.PressColEnabled = 1;
  ButtonRound1.Font_Color      = 0x0000;
  ButtonRound1.Gradient        = 1;
  ButtonRound1.Gradient_Orientation    = 0;
  ButtonRound1.Gradient_Start_Color    = 0xFFFF;
  ButtonRound1.Gradient_End_Color      = 0xC618;
  ButtonRound1.Color           = 0xC618;
  ButtonRound1.Press_Color     = 0xE71C;
  ButtonRound1.Corner_Radius   = 3;
  ButtonRound1.OnUpPtr         = 0;
  ButtonRound1.OnDownPtr       = 0;
  ButtonRound1.OnClickPtr      = ButtonRound1OnClick;
  ButtonRound1.OnPressPtr      = 0;

  ButtonRound2.OwnerScreen     = &Screen1;
  ButtonRound2.Order           = 23;
  ButtonRound2.Left            = 257;
  ButtonRound2.Top             = 107;
  ButtonRound2.Width           = 60;
  ButtonRound2.Height          = 25;
  ButtonRound2.Pen_Width       = 1;
  ButtonRound2.Pen_Color       = 0x0000;
  ButtonRound2.Visible         = 0;
  ButtonRound2.Active          = 1;
  ButtonRound2.Transparent     = 1;
  ButtonRound2.Caption         = ButtonRound2_Caption;
  ButtonRound2.TextAlign       = _taCenter;
  ButtonRound2.FontName        = Tahoma11x13_Regular;
  ButtonRound2.PressColEnabled = 1;
  ButtonRound2.Font_Color      = 0x0000;
  ButtonRound2.Gradient        = 1;
  ButtonRound2.Gradient_Orientation    = 0;
  ButtonRound2.Gradient_Start_Color    = 0xFFFF;
  ButtonRound2.Gradient_End_Color      = 0xC618;
  ButtonRound2.Color           = 0xC618;
  ButtonRound2.Press_Color     = 0xE71C;
  ButtonRound2.Corner_Radius   = 3;
  ButtonRound2.OnUpPtr         = 0;
  ButtonRound2.OnDownPtr       = 0;
  ButtonRound2.OnClickPtr      = ButtonRound2OnClick;
  ButtonRound2.OnPressPtr      = 0;

  ButtonRound3.OwnerScreen     = &Screen1;
  ButtonRound3.Order           = 24;
  ButtonRound3.Left            = 257;
  ButtonRound3.Top             = 147;
  ButtonRound3.Width           = 60;
  ButtonRound3.Height          = 25;
  ButtonRound3.Pen_Width       = 1;
  ButtonRound3.Pen_Color       = 0x0000;
  ButtonRound3.Visible         = 0;
  ButtonRound3.Active          = 1;
  ButtonRound3.Transparent     = 1;
  ButtonRound3.Caption         = ButtonRound3_Caption;
  ButtonRound3.TextAlign       = _taCenter;
  ButtonRound3.FontName        = Tahoma11x13_Regular;
  ButtonRound3.PressColEnabled = 1;
  ButtonRound3.Font_Color      = 0x0000;
  ButtonRound3.Gradient        = 1;
  ButtonRound3.Gradient_Orientation    = 0;
  ButtonRound3.Gradient_Start_Color    = 0xFFFF;
  ButtonRound3.Gradient_End_Color      = 0xC618;
  ButtonRound3.Color           = 0xC618;
  ButtonRound3.Press_Color     = 0xE71C;
  ButtonRound3.Corner_Radius   = 3;
  ButtonRound3.OnUpPtr         = 0;
  ButtonRound3.OnDownPtr       = 0;
  ButtonRound3.OnClickPtr      = ButtonRound3OnClick;
  ButtonRound3.OnPressPtr      = 0;

  ButtonRound4.OwnerScreen     = &Screen1;
  ButtonRound4.Order           = 25;
  ButtonRound4.Left            = 257;
  ButtonRound4.Top             = 187;
  ButtonRound4.Width           = 60;
  ButtonRound4.Height          = 25;
  ButtonRound4.Pen_Width       = 1;
  ButtonRound4.Pen_Color       = 0x0000;
  ButtonRound4.Visible         = 0;
  ButtonRound4.Active          = 1;
  ButtonRound4.Transparent     = 1;
  ButtonRound4.Caption         = ButtonRound4_Caption;
  ButtonRound4.TextAlign       = _taCenter;
  ButtonRound4.FontName        = Tahoma11x13_Regular;
  ButtonRound4.PressColEnabled = 1;
  ButtonRound4.Font_Color      = 0x0000;
  ButtonRound4.Gradient        = 1;
  ButtonRound4.Gradient_Orientation    = 0;
  ButtonRound4.Gradient_Start_Color    = 0xFFFF;
  ButtonRound4.Gradient_End_Color      = 0xC618;
  ButtonRound4.Color           = 0xC618;
  ButtonRound4.Press_Color     = 0xE71C;
  ButtonRound4.Corner_Radius   = 3;
  ButtonRound4.OnUpPtr         = 0;
  ButtonRound4.OnDownPtr       = 0;
  ButtonRound4.OnClickPtr      = ButtonRound4OnClick;
  ButtonRound4.OnPressPtr      = 0;

  Qwerty_BoxRound1.OwnerScreen     = &Screen2;
  Qwerty_BoxRound1.Order           = 0;
  Qwerty_BoxRound1.Left            = 1;
  Qwerty_BoxRound1.Top             = 32;
  Qwerty_BoxRound1.Width           = 319;
  Qwerty_BoxRound1.Height          = 25;
  Qwerty_BoxRound1.Pen_Width       = 1;
  Qwerty_BoxRound1.Pen_Color       = 0x0000;
  Qwerty_BoxRound1.Visible         = 1;
  Qwerty_BoxRound1.Active          = 1;
  Qwerty_BoxRound1.Transparent     = 1;
  Qwerty_BoxRound1.Gradient        = 1;
  Qwerty_BoxRound1.Gradient_Orientation    = 0;
  Qwerty_BoxRound1.Gradient_Start_Color    = 0xC618;
  Qwerty_BoxRound1.Gradient_End_Color      = 0xC618;
  Qwerty_BoxRound1.Color           = 0xC618;
  Qwerty_BoxRound1.PressColEnabled     = 1;
  Qwerty_BoxRound1.Press_Color     = 0xF810;
  Qwerty_BoxRound1.Corner_Radius   = 3;
  Qwerty_BoxRound1.OnUpPtr         = 0;
  Qwerty_BoxRound1.OnDownPtr       = 0;
  Qwerty_BoxRound1.OnClickPtr      = 0;
  Qwerty_BoxRound1.OnPressPtr      = 0;

  Qwerty_ButtonRound1.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound1.Order           = 1;
  Qwerty_ButtonRound1.Left            = 1;
  Qwerty_ButtonRound1.Top             = 73;
  Qwerty_ButtonRound1.Width           = 32;
  Qwerty_ButtonRound1.Height          = 32;
  Qwerty_ButtonRound1.Pen_Width       = 1;
  Qwerty_ButtonRound1.Pen_Color       = 0x0000;
  Qwerty_ButtonRound1.Visible         = 1;
  Qwerty_ButtonRound1.Active          = 1;
  Qwerty_ButtonRound1.Transparent     = 1;
  Qwerty_ButtonRound1.Caption         = Qwerty_ButtonRound1_Caption;
  Qwerty_ButtonRound1.TextAlign       = _taCenter;
  Qwerty_ButtonRound1.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound1.PressColEnabled = 1;
  Qwerty_ButtonRound1.Font_Color      = 0x0000;
  Qwerty_ButtonRound1.Gradient        = 1;
  Qwerty_ButtonRound1.Gradient_Orientation    = 0;
  Qwerty_ButtonRound1.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound1.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound1.Color           = 0xC618;
  Qwerty_ButtonRound1.Press_Color     = 0x8410;
  Qwerty_ButtonRound1.Corner_Radius   = 3;
  Qwerty_ButtonRound1.OnUpPtr         = 0;
  Qwerty_ButtonRound1.OnDownPtr       = 0;
  Qwerty_ButtonRound1.OnClickPtr      = Qwerty_ButtonRound1OnClick;
  Qwerty_ButtonRound1.OnPressPtr      = 0;

  Qwerty_ButtonRound2.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound2.Order           = 2;
  Qwerty_ButtonRound2.Left            = 33;
  Qwerty_ButtonRound2.Top             = 73;
  Qwerty_ButtonRound2.Width           = 32;
  Qwerty_ButtonRound2.Height          = 32;
  Qwerty_ButtonRound2.Pen_Width       = 1;
  Qwerty_ButtonRound2.Pen_Color       = 0x0000;
  Qwerty_ButtonRound2.Visible         = 1;
  Qwerty_ButtonRound2.Active          = 1;
  Qwerty_ButtonRound2.Transparent     = 1;
  Qwerty_ButtonRound2.Caption         = Qwerty_ButtonRound2_Caption;
  Qwerty_ButtonRound2.TextAlign       = _taCenter;
  Qwerty_ButtonRound2.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound2.PressColEnabled = 1;
  Qwerty_ButtonRound2.Font_Color      = 0x0000;
  Qwerty_ButtonRound2.Gradient        = 1;
  Qwerty_ButtonRound2.Gradient_Orientation    = 0;
  Qwerty_ButtonRound2.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound2.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound2.Color           = 0xC618;
  Qwerty_ButtonRound2.Press_Color     = 0x8410;
  Qwerty_ButtonRound2.Corner_Radius   = 3;
  Qwerty_ButtonRound2.OnUpPtr         = 0;
  Qwerty_ButtonRound2.OnDownPtr       = 0;
  Qwerty_ButtonRound2.OnClickPtr      = Qwerty_ButtonRound2OnClick;
  Qwerty_ButtonRound2.OnPressPtr      = 0;

  Qwerty_ButtonRound3.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound3.Order           = 3;
  Qwerty_ButtonRound3.Left            = 65;
  Qwerty_ButtonRound3.Top             = 73;
  Qwerty_ButtonRound3.Width           = 32;
  Qwerty_ButtonRound3.Height          = 32;
  Qwerty_ButtonRound3.Pen_Width       = 1;
  Qwerty_ButtonRound3.Pen_Color       = 0x0000;
  Qwerty_ButtonRound3.Visible         = 1;
  Qwerty_ButtonRound3.Active          = 1;
  Qwerty_ButtonRound3.Transparent     = 1;
  Qwerty_ButtonRound3.Caption         = Qwerty_ButtonRound3_Caption;
  Qwerty_ButtonRound3.TextAlign       = _taCenter;
  Qwerty_ButtonRound3.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound3.PressColEnabled = 1;
  Qwerty_ButtonRound3.Font_Color      = 0x0000;
  Qwerty_ButtonRound3.Gradient        = 1;
  Qwerty_ButtonRound3.Gradient_Orientation    = 0;
  Qwerty_ButtonRound3.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound3.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound3.Color           = 0xC618;
  Qwerty_ButtonRound3.Press_Color     = 0x8410;
  Qwerty_ButtonRound3.Corner_Radius   = 3;
  Qwerty_ButtonRound3.OnUpPtr         = 0;
  Qwerty_ButtonRound3.OnDownPtr       = 0;
  Qwerty_ButtonRound3.OnClickPtr      = Qwerty_ButtonRound3OnClick;
  Qwerty_ButtonRound3.OnPressPtr      = 0;

  Qwerty_ButtonRound4.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound4.Order           = 4;
  Qwerty_ButtonRound4.Left            = 97;
  Qwerty_ButtonRound4.Top             = 73;
  Qwerty_ButtonRound4.Width           = 32;
  Qwerty_ButtonRound4.Height          = 32;
  Qwerty_ButtonRound4.Pen_Width       = 1;
  Qwerty_ButtonRound4.Pen_Color       = 0x0000;
  Qwerty_ButtonRound4.Visible         = 1;
  Qwerty_ButtonRound4.Active          = 1;
  Qwerty_ButtonRound4.Transparent     = 1;
  Qwerty_ButtonRound4.Caption         = Qwerty_ButtonRound4_Caption;
  Qwerty_ButtonRound4.TextAlign       = _taCenter;
  Qwerty_ButtonRound4.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound4.PressColEnabled = 1;
  Qwerty_ButtonRound4.Font_Color      = 0x0000;
  Qwerty_ButtonRound4.Gradient        = 1;
  Qwerty_ButtonRound4.Gradient_Orientation    = 0;
  Qwerty_ButtonRound4.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound4.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound4.Color           = 0xC618;
  Qwerty_ButtonRound4.Press_Color     = 0x8410;
  Qwerty_ButtonRound4.Corner_Radius   = 3;
  Qwerty_ButtonRound4.OnUpPtr         = 0;
  Qwerty_ButtonRound4.OnDownPtr       = 0;
  Qwerty_ButtonRound4.OnClickPtr      = Qwerty_ButtonRound4OnClick;
  Qwerty_ButtonRound4.OnPressPtr      = 0;

  Qwerty_ButtonRound5.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound5.Order           = 5;
  Qwerty_ButtonRound5.Left            = 129;
  Qwerty_ButtonRound5.Top             = 73;
  Qwerty_ButtonRound5.Width           = 32;
  Qwerty_ButtonRound5.Height          = 32;
  Qwerty_ButtonRound5.Pen_Width       = 1;
  Qwerty_ButtonRound5.Pen_Color       = 0x0000;
  Qwerty_ButtonRound5.Visible         = 1;
  Qwerty_ButtonRound5.Active          = 1;
  Qwerty_ButtonRound5.Transparent     = 1;
  Qwerty_ButtonRound5.Caption         = Qwerty_ButtonRound5_Caption;
  Qwerty_ButtonRound5.TextAlign       = _taCenter;
  Qwerty_ButtonRound5.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound5.PressColEnabled = 1;
  Qwerty_ButtonRound5.Font_Color      = 0x0000;
  Qwerty_ButtonRound5.Gradient        = 1;
  Qwerty_ButtonRound5.Gradient_Orientation    = 0;
  Qwerty_ButtonRound5.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound5.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound5.Color           = 0xC618;
  Qwerty_ButtonRound5.Press_Color     = 0x8410;
  Qwerty_ButtonRound5.Corner_Radius   = 3;
  Qwerty_ButtonRound5.OnUpPtr         = 0;
  Qwerty_ButtonRound5.OnDownPtr       = 0;
  Qwerty_ButtonRound5.OnClickPtr      = Qwerty_ButtonRound5OnClick;
  Qwerty_ButtonRound5.OnPressPtr      = 0;

  Qwerty_ButtonRound6.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound6.Order           = 6;
  Qwerty_ButtonRound6.Left            = 161;
  Qwerty_ButtonRound6.Top             = 73;
  Qwerty_ButtonRound6.Width           = 32;
  Qwerty_ButtonRound6.Height          = 32;
  Qwerty_ButtonRound6.Pen_Width       = 1;
  Qwerty_ButtonRound6.Pen_Color       = 0x0000;
  Qwerty_ButtonRound6.Visible         = 1;
  Qwerty_ButtonRound6.Active          = 1;
  Qwerty_ButtonRound6.Transparent     = 1;
  Qwerty_ButtonRound6.Caption         = Qwerty_ButtonRound6_Caption;
  Qwerty_ButtonRound6.TextAlign       = _taCenter;
  Qwerty_ButtonRound6.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound6.PressColEnabled = 1;
  Qwerty_ButtonRound6.Font_Color      = 0x0000;
  Qwerty_ButtonRound6.Gradient        = 1;
  Qwerty_ButtonRound6.Gradient_Orientation    = 0;
  Qwerty_ButtonRound6.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound6.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound6.Color           = 0xC618;
  Qwerty_ButtonRound6.Press_Color     = 0x8410;
  Qwerty_ButtonRound6.Corner_Radius   = 3;
  Qwerty_ButtonRound6.OnUpPtr         = 0;
  Qwerty_ButtonRound6.OnDownPtr       = 0;
  Qwerty_ButtonRound6.OnClickPtr      = Qwerty_ButtonRound6OnClick;
  Qwerty_ButtonRound6.OnPressPtr      = 0;

  Qwerty_ButtonRound7.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound7.Order           = 7;
  Qwerty_ButtonRound7.Left            = 193;
  Qwerty_ButtonRound7.Top             = 73;
  Qwerty_ButtonRound7.Width           = 32;
  Qwerty_ButtonRound7.Height          = 32;
  Qwerty_ButtonRound7.Pen_Width       = 1;
  Qwerty_ButtonRound7.Pen_Color       = 0x0000;
  Qwerty_ButtonRound7.Visible         = 1;
  Qwerty_ButtonRound7.Active          = 1;
  Qwerty_ButtonRound7.Transparent     = 1;
  Qwerty_ButtonRound7.Caption         = Qwerty_ButtonRound7_Caption;
  Qwerty_ButtonRound7.TextAlign       = _taCenter;
  Qwerty_ButtonRound7.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound7.PressColEnabled = 1;
  Qwerty_ButtonRound7.Font_Color      = 0x0000;
  Qwerty_ButtonRound7.Gradient        = 1;
  Qwerty_ButtonRound7.Gradient_Orientation    = 0;
  Qwerty_ButtonRound7.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound7.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound7.Color           = 0xC618;
  Qwerty_ButtonRound7.Press_Color     = 0x8410;
  Qwerty_ButtonRound7.Corner_Radius   = 3;
  Qwerty_ButtonRound7.OnUpPtr         = 0;
  Qwerty_ButtonRound7.OnDownPtr       = 0;
  Qwerty_ButtonRound7.OnClickPtr      = Qwerty_ButtonRound7OnClick;
  Qwerty_ButtonRound7.OnPressPtr      = 0;

  Qwerty_ButtonRound8.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound8.Order           = 8;
  Qwerty_ButtonRound8.Left            = 225;
  Qwerty_ButtonRound8.Top             = 73;
  Qwerty_ButtonRound8.Width           = 32;
  Qwerty_ButtonRound8.Height          = 32;
  Qwerty_ButtonRound8.Pen_Width       = 1;
  Qwerty_ButtonRound8.Pen_Color       = 0x0000;
  Qwerty_ButtonRound8.Visible         = 1;
  Qwerty_ButtonRound8.Active          = 1;
  Qwerty_ButtonRound8.Transparent     = 1;
  Qwerty_ButtonRound8.Caption         = Qwerty_ButtonRound8_Caption;
  Qwerty_ButtonRound8.TextAlign       = _taCenter;
  Qwerty_ButtonRound8.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound8.PressColEnabled = 1;
  Qwerty_ButtonRound8.Font_Color      = 0x0000;
  Qwerty_ButtonRound8.Gradient        = 1;
  Qwerty_ButtonRound8.Gradient_Orientation    = 0;
  Qwerty_ButtonRound8.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound8.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound8.Color           = 0xC618;
  Qwerty_ButtonRound8.Press_Color     = 0x8410;
  Qwerty_ButtonRound8.Corner_Radius   = 3;
  Qwerty_ButtonRound8.OnUpPtr         = 0;
  Qwerty_ButtonRound8.OnDownPtr       = 0;
  Qwerty_ButtonRound8.OnClickPtr      = Qwerty_ButtonRound8OnClick;
  Qwerty_ButtonRound8.OnPressPtr      = 0;

  Qwerty_ButtonRound9.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound9.Order           = 9;
  Qwerty_ButtonRound9.Left            = 257;
  Qwerty_ButtonRound9.Top             = 73;
  Qwerty_ButtonRound9.Width           = 32;
  Qwerty_ButtonRound9.Height          = 32;
  Qwerty_ButtonRound9.Pen_Width       = 1;
  Qwerty_ButtonRound9.Pen_Color       = 0x0000;
  Qwerty_ButtonRound9.Visible         = 1;
  Qwerty_ButtonRound9.Active          = 1;
  Qwerty_ButtonRound9.Transparent     = 1;
  Qwerty_ButtonRound9.Caption         = Qwerty_ButtonRound9_Caption;
  Qwerty_ButtonRound9.TextAlign       = _taCenter;
  Qwerty_ButtonRound9.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound9.PressColEnabled = 1;
  Qwerty_ButtonRound9.Font_Color      = 0x0000;
  Qwerty_ButtonRound9.Gradient        = 1;
  Qwerty_ButtonRound9.Gradient_Orientation    = 0;
  Qwerty_ButtonRound9.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound9.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound9.Color           = 0xC618;
  Qwerty_ButtonRound9.Press_Color     = 0x8410;
  Qwerty_ButtonRound9.Corner_Radius   = 3;
  Qwerty_ButtonRound9.OnUpPtr         = 0;
  Qwerty_ButtonRound9.OnDownPtr       = 0;
  Qwerty_ButtonRound9.OnClickPtr      = Qwerty_ButtonRound9OnClick;
  Qwerty_ButtonRound9.OnPressPtr      = 0;

  Qwerty_ButtonRound10.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound10.Order           = 10;
  Qwerty_ButtonRound10.Left            = 289;
  Qwerty_ButtonRound10.Top             = 73;
  Qwerty_ButtonRound10.Width           = 32;
  Qwerty_ButtonRound10.Height          = 32;
  Qwerty_ButtonRound10.Pen_Width       = 1;
  Qwerty_ButtonRound10.Pen_Color       = 0x0000;
  Qwerty_ButtonRound10.Visible         = 1;
  Qwerty_ButtonRound10.Active          = 1;
  Qwerty_ButtonRound10.Transparent     = 1;
  Qwerty_ButtonRound10.Caption         = Qwerty_ButtonRound10_Caption;
  Qwerty_ButtonRound10.TextAlign       = _taCenter;
  Qwerty_ButtonRound10.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound10.PressColEnabled = 1;
  Qwerty_ButtonRound10.Font_Color      = 0x0000;
  Qwerty_ButtonRound10.Gradient        = 1;
  Qwerty_ButtonRound10.Gradient_Orientation    = 0;
  Qwerty_ButtonRound10.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound10.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound10.Color           = 0xC618;
  Qwerty_ButtonRound10.Press_Color     = 0x8410;
  Qwerty_ButtonRound10.Corner_Radius   = 3;
  Qwerty_ButtonRound10.OnUpPtr         = 0;
  Qwerty_ButtonRound10.OnDownPtr       = 0;
  Qwerty_ButtonRound10.OnClickPtr      = Qwerty_ButtonRound10OnClick;
  Qwerty_ButtonRound10.OnPressPtr      = 0;

  Qwerty_ButtonRound11.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound11.Order           = 11;
  Qwerty_ButtonRound11.Left            = 1;
  Qwerty_ButtonRound11.Top             = 105;
  Qwerty_ButtonRound11.Width           = 32;
  Qwerty_ButtonRound11.Height          = 32;
  Qwerty_ButtonRound11.Pen_Width       = 1;
  Qwerty_ButtonRound11.Pen_Color       = 0x0000;
  Qwerty_ButtonRound11.Visible         = 1;
  Qwerty_ButtonRound11.Active          = 1;
  Qwerty_ButtonRound11.Transparent     = 1;
  Qwerty_ButtonRound11.Caption         = Qwerty_ButtonRound11_Caption;
  Qwerty_ButtonRound11.TextAlign       = _taCenter;
  Qwerty_ButtonRound11.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound11.PressColEnabled = 1;
  Qwerty_ButtonRound11.Font_Color      = 0x0000;
  Qwerty_ButtonRound11.Gradient        = 1;
  Qwerty_ButtonRound11.Gradient_Orientation    = 0;
  Qwerty_ButtonRound11.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound11.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound11.Color           = 0xC618;
  Qwerty_ButtonRound11.Press_Color     = 0x8410;
  Qwerty_ButtonRound11.Corner_Radius   = 3;
  Qwerty_ButtonRound11.OnUpPtr         = 0;
  Qwerty_ButtonRound11.OnDownPtr       = 0;
  Qwerty_ButtonRound11.OnClickPtr      = Qwerty_ButtonRound11OnClick;
  Qwerty_ButtonRound11.OnPressPtr      = 0;

  Qwerty_ButtonRound12.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound12.Order           = 12;
  Qwerty_ButtonRound12.Left            = 33;
  Qwerty_ButtonRound12.Top             = 105;
  Qwerty_ButtonRound12.Width           = 32;
  Qwerty_ButtonRound12.Height          = 32;
  Qwerty_ButtonRound12.Pen_Width       = 1;
  Qwerty_ButtonRound12.Pen_Color       = 0x0000;
  Qwerty_ButtonRound12.Visible         = 1;
  Qwerty_ButtonRound12.Active          = 1;
  Qwerty_ButtonRound12.Transparent     = 1;
  Qwerty_ButtonRound12.Caption         = Qwerty_ButtonRound12_Caption;
  Qwerty_ButtonRound12.TextAlign       = _taCenter;
  Qwerty_ButtonRound12.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound12.PressColEnabled = 1;
  Qwerty_ButtonRound12.Font_Color      = 0x0000;
  Qwerty_ButtonRound12.Gradient        = 1;
  Qwerty_ButtonRound12.Gradient_Orientation    = 0;
  Qwerty_ButtonRound12.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound12.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound12.Color           = 0xC618;
  Qwerty_ButtonRound12.Press_Color     = 0x8410;
  Qwerty_ButtonRound12.Corner_Radius   = 3;
  Qwerty_ButtonRound12.OnUpPtr         = 0;
  Qwerty_ButtonRound12.OnDownPtr       = 0;
  Qwerty_ButtonRound12.OnClickPtr      = Qwerty_ButtonRound12OnClick;
  Qwerty_ButtonRound12.OnPressPtr      = 0;

  Qwerty_ButtonRound13.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound13.Order           = 13;
  Qwerty_ButtonRound13.Left            = 65;
  Qwerty_ButtonRound13.Top             = 105;
  Qwerty_ButtonRound13.Width           = 32;
  Qwerty_ButtonRound13.Height          = 32;
  Qwerty_ButtonRound13.Pen_Width       = 1;
  Qwerty_ButtonRound13.Pen_Color       = 0x0000;
  Qwerty_ButtonRound13.Visible         = 1;
  Qwerty_ButtonRound13.Active          = 1;
  Qwerty_ButtonRound13.Transparent     = 1;
  Qwerty_ButtonRound13.Caption         = Qwerty_ButtonRound13_Caption;
  Qwerty_ButtonRound13.TextAlign       = _taCenter;
  Qwerty_ButtonRound13.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound13.PressColEnabled = 1;
  Qwerty_ButtonRound13.Font_Color      = 0x0000;
  Qwerty_ButtonRound13.Gradient        = 1;
  Qwerty_ButtonRound13.Gradient_Orientation    = 0;
  Qwerty_ButtonRound13.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound13.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound13.Color           = 0xC618;
  Qwerty_ButtonRound13.Press_Color     = 0x8410;
  Qwerty_ButtonRound13.Corner_Radius   = 3;
  Qwerty_ButtonRound13.OnUpPtr         = 0;
  Qwerty_ButtonRound13.OnDownPtr       = 0;
  Qwerty_ButtonRound13.OnClickPtr      = Qwerty_ButtonRound13OnClick;
  Qwerty_ButtonRound13.OnPressPtr      = 0;

  Qwerty_ButtonRound14.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound14.Order           = 14;
  Qwerty_ButtonRound14.Left            = 97;
  Qwerty_ButtonRound14.Top             = 105;
  Qwerty_ButtonRound14.Width           = 32;
  Qwerty_ButtonRound14.Height          = 32;
  Qwerty_ButtonRound14.Pen_Width       = 1;
  Qwerty_ButtonRound14.Pen_Color       = 0x0000;
  Qwerty_ButtonRound14.Visible         = 1;
  Qwerty_ButtonRound14.Active          = 1;
  Qwerty_ButtonRound14.Transparent     = 1;
  Qwerty_ButtonRound14.Caption         = Qwerty_ButtonRound14_Caption;
  Qwerty_ButtonRound14.TextAlign       = _taCenter;
  Qwerty_ButtonRound14.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound14.PressColEnabled = 1;
  Qwerty_ButtonRound14.Font_Color      = 0x0000;
  Qwerty_ButtonRound14.Gradient        = 1;
  Qwerty_ButtonRound14.Gradient_Orientation    = 0;
  Qwerty_ButtonRound14.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound14.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound14.Color           = 0xC618;
  Qwerty_ButtonRound14.Press_Color     = 0x8410;
  Qwerty_ButtonRound14.Corner_Radius   = 3;
  Qwerty_ButtonRound14.OnUpPtr         = 0;
  Qwerty_ButtonRound14.OnDownPtr       = 0;
  Qwerty_ButtonRound14.OnClickPtr      = Qwerty_ButtonRound14OnClick;
  Qwerty_ButtonRound14.OnPressPtr      = 0;

  Qwerty_ButtonRound15.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound15.Order           = 15;
  Qwerty_ButtonRound15.Left            = 129;
  Qwerty_ButtonRound15.Top             = 105;
  Qwerty_ButtonRound15.Width           = 32;
  Qwerty_ButtonRound15.Height          = 32;
  Qwerty_ButtonRound15.Pen_Width       = 1;
  Qwerty_ButtonRound15.Pen_Color       = 0x0000;
  Qwerty_ButtonRound15.Visible         = 1;
  Qwerty_ButtonRound15.Active          = 1;
  Qwerty_ButtonRound15.Transparent     = 1;
  Qwerty_ButtonRound15.Caption         = Qwerty_ButtonRound15_Caption;
  Qwerty_ButtonRound15.TextAlign       = _taCenter;
  Qwerty_ButtonRound15.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound15.PressColEnabled = 1;
  Qwerty_ButtonRound15.Font_Color      = 0x0000;
  Qwerty_ButtonRound15.Gradient        = 1;
  Qwerty_ButtonRound15.Gradient_Orientation    = 0;
  Qwerty_ButtonRound15.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound15.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound15.Color           = 0xC618;
  Qwerty_ButtonRound15.Press_Color     = 0x8410;
  Qwerty_ButtonRound15.Corner_Radius   = 3;
  Qwerty_ButtonRound15.OnUpPtr         = 0;
  Qwerty_ButtonRound15.OnDownPtr       = 0;
  Qwerty_ButtonRound15.OnClickPtr      = Qwerty_ButtonRound15OnClick;
  Qwerty_ButtonRound15.OnPressPtr      = 0;

  Qwerty_ButtonRound16.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound16.Order           = 16;
  Qwerty_ButtonRound16.Left            = 161;
  Qwerty_ButtonRound16.Top             = 105;
  Qwerty_ButtonRound16.Width           = 32;
  Qwerty_ButtonRound16.Height          = 32;
  Qwerty_ButtonRound16.Pen_Width       = 1;
  Qwerty_ButtonRound16.Pen_Color       = 0x0000;
  Qwerty_ButtonRound16.Visible         = 1;
  Qwerty_ButtonRound16.Active          = 1;
  Qwerty_ButtonRound16.Transparent     = 1;
  Qwerty_ButtonRound16.Caption         = Qwerty_ButtonRound16_Caption;
  Qwerty_ButtonRound16.TextAlign       = _taCenter;
  Qwerty_ButtonRound16.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound16.PressColEnabled = 1;
  Qwerty_ButtonRound16.Font_Color      = 0x0000;
  Qwerty_ButtonRound16.Gradient        = 1;
  Qwerty_ButtonRound16.Gradient_Orientation    = 0;
  Qwerty_ButtonRound16.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound16.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound16.Color           = 0xC618;
  Qwerty_ButtonRound16.Press_Color     = 0x8410;
  Qwerty_ButtonRound16.Corner_Radius   = 3;
  Qwerty_ButtonRound16.OnUpPtr         = 0;
  Qwerty_ButtonRound16.OnDownPtr       = 0;
  Qwerty_ButtonRound16.OnClickPtr      = Qwerty_ButtonRound16OnClick;
  Qwerty_ButtonRound16.OnPressPtr      = 0;

  Qwerty_ButtonRound17.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound17.Order           = 17;
  Qwerty_ButtonRound17.Left            = 193;
  Qwerty_ButtonRound17.Top             = 105;
  Qwerty_ButtonRound17.Width           = 32;
  Qwerty_ButtonRound17.Height          = 32;
  Qwerty_ButtonRound17.Pen_Width       = 1;
  Qwerty_ButtonRound17.Pen_Color       = 0x0000;
  Qwerty_ButtonRound17.Visible         = 1;
  Qwerty_ButtonRound17.Active          = 1;
  Qwerty_ButtonRound17.Transparent     = 1;
  Qwerty_ButtonRound17.Caption         = Qwerty_ButtonRound17_Caption;
  Qwerty_ButtonRound17.TextAlign       = _taCenter;
  Qwerty_ButtonRound17.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound17.PressColEnabled = 1;
  Qwerty_ButtonRound17.Font_Color      = 0x0000;
  Qwerty_ButtonRound17.Gradient        = 1;
  Qwerty_ButtonRound17.Gradient_Orientation    = 0;
  Qwerty_ButtonRound17.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound17.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound17.Color           = 0xC618;
  Qwerty_ButtonRound17.Press_Color     = 0x8410;
  Qwerty_ButtonRound17.Corner_Radius   = 3;
  Qwerty_ButtonRound17.OnUpPtr         = 0;
  Qwerty_ButtonRound17.OnDownPtr       = 0;
  Qwerty_ButtonRound17.OnClickPtr      = Qwerty_ButtonRound17OnClick;
  Qwerty_ButtonRound17.OnPressPtr      = 0;

  Qwerty_ButtonRound18.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound18.Order           = 18;
  Qwerty_ButtonRound18.Left            = 225;
  Qwerty_ButtonRound18.Top             = 105;
  Qwerty_ButtonRound18.Width           = 32;
  Qwerty_ButtonRound18.Height          = 32;
  Qwerty_ButtonRound18.Pen_Width       = 1;
  Qwerty_ButtonRound18.Pen_Color       = 0x0000;
  Qwerty_ButtonRound18.Visible         = 1;
  Qwerty_ButtonRound18.Active          = 1;
  Qwerty_ButtonRound18.Transparent     = 1;
  Qwerty_ButtonRound18.Caption         = Qwerty_ButtonRound18_Caption;
  Qwerty_ButtonRound18.TextAlign       = _taCenter;
  Qwerty_ButtonRound18.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound18.PressColEnabled = 1;
  Qwerty_ButtonRound18.Font_Color      = 0x0000;
  Qwerty_ButtonRound18.Gradient        = 1;
  Qwerty_ButtonRound18.Gradient_Orientation    = 0;
  Qwerty_ButtonRound18.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound18.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound18.Color           = 0xC618;
  Qwerty_ButtonRound18.Press_Color     = 0x8410;
  Qwerty_ButtonRound18.Corner_Radius   = 3;
  Qwerty_ButtonRound18.OnUpPtr         = 0;
  Qwerty_ButtonRound18.OnDownPtr       = 0;
  Qwerty_ButtonRound18.OnClickPtr      = Qwerty_ButtonRound18OnClick;
  Qwerty_ButtonRound18.OnPressPtr      = 0;

  Qwerty_ButtonRound19.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound19.Order           = 19;
  Qwerty_ButtonRound19.Left            = 257;
  Qwerty_ButtonRound19.Top             = 105;
  Qwerty_ButtonRound19.Width           = 32;
  Qwerty_ButtonRound19.Height          = 32;
  Qwerty_ButtonRound19.Pen_Width       = 1;
  Qwerty_ButtonRound19.Pen_Color       = 0x0000;
  Qwerty_ButtonRound19.Visible         = 1;
  Qwerty_ButtonRound19.Active          = 1;
  Qwerty_ButtonRound19.Transparent     = 1;
  Qwerty_ButtonRound19.Caption         = Qwerty_ButtonRound19_Caption;
  Qwerty_ButtonRound19.TextAlign       = _taCenter;
  Qwerty_ButtonRound19.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound19.PressColEnabled = 1;
  Qwerty_ButtonRound19.Font_Color      = 0x0000;
  Qwerty_ButtonRound19.Gradient        = 1;
  Qwerty_ButtonRound19.Gradient_Orientation    = 0;
  Qwerty_ButtonRound19.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound19.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound19.Color           = 0xC618;
  Qwerty_ButtonRound19.Press_Color     = 0x8410;
  Qwerty_ButtonRound19.Corner_Radius   = 3;
  Qwerty_ButtonRound19.OnUpPtr         = 0;
  Qwerty_ButtonRound19.OnDownPtr       = 0;
  Qwerty_ButtonRound19.OnClickPtr      = Qwerty_ButtonRound19OnClick;
  Qwerty_ButtonRound19.OnPressPtr      = 0;

  Qwerty_ButtonRound20.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound20.Order           = 20;
  Qwerty_ButtonRound20.Left            = 289;
  Qwerty_ButtonRound20.Top             = 105;
  Qwerty_ButtonRound20.Width           = 32;
  Qwerty_ButtonRound20.Height          = 32;
  Qwerty_ButtonRound20.Pen_Width       = 1;
  Qwerty_ButtonRound20.Pen_Color       = 0x0000;
  Qwerty_ButtonRound20.Visible         = 1;
  Qwerty_ButtonRound20.Active          = 1;
  Qwerty_ButtonRound20.Transparent     = 1;
  Qwerty_ButtonRound20.Caption         = Qwerty_ButtonRound20_Caption;
  Qwerty_ButtonRound20.TextAlign       = _taCenter;
  Qwerty_ButtonRound20.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound20.PressColEnabled = 1;
  Qwerty_ButtonRound20.Font_Color      = 0x0000;
  Qwerty_ButtonRound20.Gradient        = 1;
  Qwerty_ButtonRound20.Gradient_Orientation    = 0;
  Qwerty_ButtonRound20.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound20.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound20.Color           = 0xC618;
  Qwerty_ButtonRound20.Press_Color     = 0x8410;
  Qwerty_ButtonRound20.Corner_Radius   = 3;
  Qwerty_ButtonRound20.OnUpPtr         = 0;
  Qwerty_ButtonRound20.OnDownPtr       = 0;
  Qwerty_ButtonRound20.OnClickPtr      = Qwerty_ButtonRound20OnClick;
  Qwerty_ButtonRound20.OnPressPtr      = 0;

  Qwerty_ButtonRound21.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound21.Order           = 21;
  Qwerty_ButtonRound21.Left            = 1;
  Qwerty_ButtonRound21.Top             = 137;
  Qwerty_ButtonRound21.Width           = 32;
  Qwerty_ButtonRound21.Height          = 32;
  Qwerty_ButtonRound21.Pen_Width       = 1;
  Qwerty_ButtonRound21.Pen_Color       = 0x0000;
  Qwerty_ButtonRound21.Visible         = 1;
  Qwerty_ButtonRound21.Active          = 1;
  Qwerty_ButtonRound21.Transparent     = 1;
  Qwerty_ButtonRound21.Caption         = Qwerty_ButtonRound21_Caption;
  Qwerty_ButtonRound21.TextAlign       = _taCenter;
  Qwerty_ButtonRound21.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound21.PressColEnabled = 1;
  Qwerty_ButtonRound21.Font_Color      = 0x0000;
  Qwerty_ButtonRound21.Gradient        = 1;
  Qwerty_ButtonRound21.Gradient_Orientation    = 0;
  Qwerty_ButtonRound21.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound21.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound21.Color           = 0xC618;
  Qwerty_ButtonRound21.Press_Color     = 0x8410;
  Qwerty_ButtonRound21.Corner_Radius   = 3;
  Qwerty_ButtonRound21.OnUpPtr         = 0;
  Qwerty_ButtonRound21.OnDownPtr       = 0;
  Qwerty_ButtonRound21.OnClickPtr      = Qwerty_ButtonRound21OnClick;
  Qwerty_ButtonRound21.OnPressPtr      = 0;

  Qwerty_ButtonRound22.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound22.Order           = 22;
  Qwerty_ButtonRound22.Left            = 33;
  Qwerty_ButtonRound22.Top             = 137;
  Qwerty_ButtonRound22.Width           = 32;
  Qwerty_ButtonRound22.Height          = 32;
  Qwerty_ButtonRound22.Pen_Width       = 1;
  Qwerty_ButtonRound22.Pen_Color       = 0x0000;
  Qwerty_ButtonRound22.Visible         = 1;
  Qwerty_ButtonRound22.Active          = 1;
  Qwerty_ButtonRound22.Transparent     = 1;
  Qwerty_ButtonRound22.Caption         = Qwerty_ButtonRound22_Caption;
  Qwerty_ButtonRound22.TextAlign       = _taCenter;
  Qwerty_ButtonRound22.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound22.PressColEnabled = 1;
  Qwerty_ButtonRound22.Font_Color      = 0x0000;
  Qwerty_ButtonRound22.Gradient        = 1;
  Qwerty_ButtonRound22.Gradient_Orientation    = 0;
  Qwerty_ButtonRound22.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound22.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound22.Color           = 0xC618;
  Qwerty_ButtonRound22.Press_Color     = 0x8410;
  Qwerty_ButtonRound22.Corner_Radius   = 3;
  Qwerty_ButtonRound22.OnUpPtr         = 0;
  Qwerty_ButtonRound22.OnDownPtr       = 0;
  Qwerty_ButtonRound22.OnClickPtr      = Qwerty_ButtonRound22OnClick;
  Qwerty_ButtonRound22.OnPressPtr      = 0;

  Qwerty_ButtonRound23.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound23.Order           = 23;
  Qwerty_ButtonRound23.Left            = 65;
  Qwerty_ButtonRound23.Top             = 137;
  Qwerty_ButtonRound23.Width           = 32;
  Qwerty_ButtonRound23.Height          = 32;
  Qwerty_ButtonRound23.Pen_Width       = 1;
  Qwerty_ButtonRound23.Pen_Color       = 0x0000;
  Qwerty_ButtonRound23.Visible         = 1;
  Qwerty_ButtonRound23.Active          = 1;
  Qwerty_ButtonRound23.Transparent     = 1;
  Qwerty_ButtonRound23.Caption         = Qwerty_ButtonRound23_Caption;
  Qwerty_ButtonRound23.TextAlign       = _taCenter;
  Qwerty_ButtonRound23.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound23.PressColEnabled = 1;
  Qwerty_ButtonRound23.Font_Color      = 0x0000;
  Qwerty_ButtonRound23.Gradient        = 1;
  Qwerty_ButtonRound23.Gradient_Orientation    = 0;
  Qwerty_ButtonRound23.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound23.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound23.Color           = 0xC618;
  Qwerty_ButtonRound23.Press_Color     = 0x8410;
  Qwerty_ButtonRound23.Corner_Radius   = 3;
  Qwerty_ButtonRound23.OnUpPtr         = 0;
  Qwerty_ButtonRound23.OnDownPtr       = 0;
  Qwerty_ButtonRound23.OnClickPtr      = Qwerty_ButtonRound23OnClick;
  Qwerty_ButtonRound23.OnPressPtr      = 0;

  Qwerty_ButtonRound24.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound24.Order           = 24;
  Qwerty_ButtonRound24.Left            = 97;
  Qwerty_ButtonRound24.Top             = 137;
  Qwerty_ButtonRound24.Width           = 32;
  Qwerty_ButtonRound24.Height          = 32;
  Qwerty_ButtonRound24.Pen_Width       = 1;
  Qwerty_ButtonRound24.Pen_Color       = 0x0000;
  Qwerty_ButtonRound24.Visible         = 1;
  Qwerty_ButtonRound24.Active          = 1;
  Qwerty_ButtonRound24.Transparent     = 1;
  Qwerty_ButtonRound24.Caption         = Qwerty_ButtonRound24_Caption;
  Qwerty_ButtonRound24.TextAlign       = _taCenter;
  Qwerty_ButtonRound24.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound24.PressColEnabled = 1;
  Qwerty_ButtonRound24.Font_Color      = 0x0000;
  Qwerty_ButtonRound24.Gradient        = 1;
  Qwerty_ButtonRound24.Gradient_Orientation    = 0;
  Qwerty_ButtonRound24.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound24.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound24.Color           = 0xC618;
  Qwerty_ButtonRound24.Press_Color     = 0x8410;
  Qwerty_ButtonRound24.Corner_Radius   = 3;
  Qwerty_ButtonRound24.OnUpPtr         = 0;
  Qwerty_ButtonRound24.OnDownPtr       = 0;
  Qwerty_ButtonRound24.OnClickPtr      = Qwerty_ButtonRound24OnClick;
  Qwerty_ButtonRound24.OnPressPtr      = 0;

  Qwerty_ButtonRound25.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound25.Order           = 25;
  Qwerty_ButtonRound25.Left            = 129;
  Qwerty_ButtonRound25.Top             = 137;
  Qwerty_ButtonRound25.Width           = 32;
  Qwerty_ButtonRound25.Height          = 32;
  Qwerty_ButtonRound25.Pen_Width       = 1;
  Qwerty_ButtonRound25.Pen_Color       = 0x0000;
  Qwerty_ButtonRound25.Visible         = 1;
  Qwerty_ButtonRound25.Active          = 1;
  Qwerty_ButtonRound25.Transparent     = 1;
  Qwerty_ButtonRound25.Caption         = Qwerty_ButtonRound25_Caption;
  Qwerty_ButtonRound25.TextAlign       = _taCenter;
  Qwerty_ButtonRound25.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound25.PressColEnabled = 1;
  Qwerty_ButtonRound25.Font_Color      = 0x0000;
  Qwerty_ButtonRound25.Gradient        = 1;
  Qwerty_ButtonRound25.Gradient_Orientation    = 0;
  Qwerty_ButtonRound25.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound25.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound25.Color           = 0xC618;
  Qwerty_ButtonRound25.Press_Color     = 0x8410;
  Qwerty_ButtonRound25.Corner_Radius   = 3;
  Qwerty_ButtonRound25.OnUpPtr         = 0;
  Qwerty_ButtonRound25.OnDownPtr       = 0;
  Qwerty_ButtonRound25.OnClickPtr      = Qwerty_ButtonRound25OnClick;
  Qwerty_ButtonRound25.OnPressPtr      = 0;

  Qwerty_ButtonRound26.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound26.Order           = 26;
  Qwerty_ButtonRound26.Left            = 161;
  Qwerty_ButtonRound26.Top             = 137;
  Qwerty_ButtonRound26.Width           = 32;
  Qwerty_ButtonRound26.Height          = 32;
  Qwerty_ButtonRound26.Pen_Width       = 1;
  Qwerty_ButtonRound26.Pen_Color       = 0x0000;
  Qwerty_ButtonRound26.Visible         = 1;
  Qwerty_ButtonRound26.Active          = 1;
  Qwerty_ButtonRound26.Transparent     = 1;
  Qwerty_ButtonRound26.Caption         = Qwerty_ButtonRound26_Caption;
  Qwerty_ButtonRound26.TextAlign       = _taCenter;
  Qwerty_ButtonRound26.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound26.PressColEnabled = 1;
  Qwerty_ButtonRound26.Font_Color      = 0x0000;
  Qwerty_ButtonRound26.Gradient        = 1;
  Qwerty_ButtonRound26.Gradient_Orientation    = 0;
  Qwerty_ButtonRound26.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound26.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound26.Color           = 0xC618;
  Qwerty_ButtonRound26.Press_Color     = 0x8410;
  Qwerty_ButtonRound26.Corner_Radius   = 3;
  Qwerty_ButtonRound26.OnUpPtr         = 0;
  Qwerty_ButtonRound26.OnDownPtr       = 0;
  Qwerty_ButtonRound26.OnClickPtr      = Qwerty_ButtonRound26OnClick;
  Qwerty_ButtonRound26.OnPressPtr      = 0;

  Qwerty_ButtonRound27.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound27.Order           = 27;
  Qwerty_ButtonRound27.Left            = 193;
  Qwerty_ButtonRound27.Top             = 137;
  Qwerty_ButtonRound27.Width           = 32;
  Qwerty_ButtonRound27.Height          = 32;
  Qwerty_ButtonRound27.Pen_Width       = 1;
  Qwerty_ButtonRound27.Pen_Color       = 0x0000;
  Qwerty_ButtonRound27.Visible         = 1;
  Qwerty_ButtonRound27.Active          = 1;
  Qwerty_ButtonRound27.Transparent     = 1;
  Qwerty_ButtonRound27.Caption         = Qwerty_ButtonRound27_Caption;
  Qwerty_ButtonRound27.TextAlign       = _taCenter;
  Qwerty_ButtonRound27.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound27.PressColEnabled = 1;
  Qwerty_ButtonRound27.Font_Color      = 0x0000;
  Qwerty_ButtonRound27.Gradient        = 1;
  Qwerty_ButtonRound27.Gradient_Orientation    = 0;
  Qwerty_ButtonRound27.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound27.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound27.Color           = 0xC618;
  Qwerty_ButtonRound27.Press_Color     = 0x8410;
  Qwerty_ButtonRound27.Corner_Radius   = 3;
  Qwerty_ButtonRound27.OnUpPtr         = 0;
  Qwerty_ButtonRound27.OnDownPtr       = 0;
  Qwerty_ButtonRound27.OnClickPtr      = Qwerty_ButtonRound27OnClick;
  Qwerty_ButtonRound27.OnPressPtr      = 0;

  Qwerty_ButtonRound28.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound28.Order           = 28;
  Qwerty_ButtonRound28.Left            = 225;
  Qwerty_ButtonRound28.Top             = 137;
  Qwerty_ButtonRound28.Width           = 32;
  Qwerty_ButtonRound28.Height          = 32;
  Qwerty_ButtonRound28.Pen_Width       = 1;
  Qwerty_ButtonRound28.Pen_Color       = 0x0000;
  Qwerty_ButtonRound28.Visible         = 1;
  Qwerty_ButtonRound28.Active          = 1;
  Qwerty_ButtonRound28.Transparent     = 1;
  Qwerty_ButtonRound28.Caption         = Qwerty_ButtonRound28_Caption;
  Qwerty_ButtonRound28.TextAlign       = _taCenter;
  Qwerty_ButtonRound28.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound28.PressColEnabled = 1;
  Qwerty_ButtonRound28.Font_Color      = 0x0000;
  Qwerty_ButtonRound28.Gradient        = 1;
  Qwerty_ButtonRound28.Gradient_Orientation    = 0;
  Qwerty_ButtonRound28.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound28.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound28.Color           = 0xC618;
  Qwerty_ButtonRound28.Press_Color     = 0x8410;
  Qwerty_ButtonRound28.Corner_Radius   = 3;
  Qwerty_ButtonRound28.OnUpPtr         = 0;
  Qwerty_ButtonRound28.OnDownPtr       = 0;
  Qwerty_ButtonRound28.OnClickPtr      = Qwerty_ButtonRound28OnClick;
  Qwerty_ButtonRound28.OnPressPtr      = 0;

  Qwerty_ButtonRound29.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound29.Order           = 29;
  Qwerty_ButtonRound29.Left            = 257;
  Qwerty_ButtonRound29.Top             = 137;
  Qwerty_ButtonRound29.Width           = 32;
  Qwerty_ButtonRound29.Height          = 32;
  Qwerty_ButtonRound29.Pen_Width       = 1;
  Qwerty_ButtonRound29.Pen_Color       = 0x0000;
  Qwerty_ButtonRound29.Visible         = 1;
  Qwerty_ButtonRound29.Active          = 1;
  Qwerty_ButtonRound29.Transparent     = 1;
  Qwerty_ButtonRound29.Caption         = Qwerty_ButtonRound29_Caption;
  Qwerty_ButtonRound29.TextAlign       = _taCenter;
  Qwerty_ButtonRound29.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound29.PressColEnabled = 1;
  Qwerty_ButtonRound29.Font_Color      = 0x0000;
  Qwerty_ButtonRound29.Gradient        = 1;
  Qwerty_ButtonRound29.Gradient_Orientation    = 0;
  Qwerty_ButtonRound29.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound29.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound29.Color           = 0xC618;
  Qwerty_ButtonRound29.Press_Color     = 0x8410;
  Qwerty_ButtonRound29.Corner_Radius   = 3;
  Qwerty_ButtonRound29.OnUpPtr         = 0;
  Qwerty_ButtonRound29.OnDownPtr       = 0;
  Qwerty_ButtonRound29.OnClickPtr      = Qwerty_ButtonRound29OnClick;
  Qwerty_ButtonRound29.OnPressPtr      = 0;

  Qwerty_ButtonRound30.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound30.Order           = 30;
  Qwerty_ButtonRound30.Left            = 289;
  Qwerty_ButtonRound30.Top             = 137;
  Qwerty_ButtonRound30.Width           = 32;
  Qwerty_ButtonRound30.Height          = 32;
  Qwerty_ButtonRound30.Pen_Width       = 1;
  Qwerty_ButtonRound30.Pen_Color       = 0x0000;
  Qwerty_ButtonRound30.Visible         = 1;
  Qwerty_ButtonRound30.Active          = 1;
  Qwerty_ButtonRound30.Transparent     = 1;
  Qwerty_ButtonRound30.Caption         = Qwerty_ButtonRound30_Caption;
  Qwerty_ButtonRound30.TextAlign       = _taCenter;
  Qwerty_ButtonRound30.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound30.PressColEnabled = 1;
  Qwerty_ButtonRound30.Font_Color      = 0x0000;
  Qwerty_ButtonRound30.Gradient        = 1;
  Qwerty_ButtonRound30.Gradient_Orientation    = 0;
  Qwerty_ButtonRound30.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound30.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound30.Color           = 0xC618;
  Qwerty_ButtonRound30.Press_Color     = 0x8410;
  Qwerty_ButtonRound30.Corner_Radius   = 3;
  Qwerty_ButtonRound30.OnUpPtr         = 0;
  Qwerty_ButtonRound30.OnDownPtr       = 0;
  Qwerty_ButtonRound30.OnClickPtr      = Qwerty_ButtonRound30OnClick;
  Qwerty_ButtonRound30.OnPressPtr      = 0;

  Qwerty_ButtonRound31.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound31.Order           = 31;
  Qwerty_ButtonRound31.Left            = 1;
  Qwerty_ButtonRound31.Top             = 169;
  Qwerty_ButtonRound31.Width           = 32;
  Qwerty_ButtonRound31.Height          = 32;
  Qwerty_ButtonRound31.Pen_Width       = 1;
  Qwerty_ButtonRound31.Pen_Color       = 0x0000;
  Qwerty_ButtonRound31.Visible         = 1;
  Qwerty_ButtonRound31.Active          = 1;
  Qwerty_ButtonRound31.Transparent     = 1;
  Qwerty_ButtonRound31.Caption         = Qwerty_ButtonRound31_Caption;
  Qwerty_ButtonRound31.TextAlign       = _taCenter;
  Qwerty_ButtonRound31.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound31.PressColEnabled = 1;
  Qwerty_ButtonRound31.Font_Color      = 0x0000;
  Qwerty_ButtonRound31.Gradient        = 1;
  Qwerty_ButtonRound31.Gradient_Orientation    = 0;
  Qwerty_ButtonRound31.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound31.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound31.Color           = 0xC618;
  Qwerty_ButtonRound31.Press_Color     = 0x8410;
  Qwerty_ButtonRound31.Corner_Radius   = 3;
  Qwerty_ButtonRound31.OnUpPtr         = 0;
  Qwerty_ButtonRound31.OnDownPtr       = 0;
  Qwerty_ButtonRound31.OnClickPtr      = Qwerty_ButtonRound31OnClick;
  Qwerty_ButtonRound31.OnPressPtr      = 0;

  Qwerty_ButtonRound32.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound32.Order           = 32;
  Qwerty_ButtonRound32.Left            = 33;
  Qwerty_ButtonRound32.Top             = 169;
  Qwerty_ButtonRound32.Width           = 32;
  Qwerty_ButtonRound32.Height          = 32;
  Qwerty_ButtonRound32.Pen_Width       = 1;
  Qwerty_ButtonRound32.Pen_Color       = 0x0000;
  Qwerty_ButtonRound32.Visible         = 1;
  Qwerty_ButtonRound32.Active          = 1;
  Qwerty_ButtonRound32.Transparent     = 1;
  Qwerty_ButtonRound32.Caption         = Qwerty_ButtonRound32_Caption;
  Qwerty_ButtonRound32.TextAlign       = _taCenter;
  Qwerty_ButtonRound32.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound32.PressColEnabled = 1;
  Qwerty_ButtonRound32.Font_Color      = 0x0000;
  Qwerty_ButtonRound32.Gradient        = 1;
  Qwerty_ButtonRound32.Gradient_Orientation    = 0;
  Qwerty_ButtonRound32.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound32.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound32.Color           = 0xC618;
  Qwerty_ButtonRound32.Press_Color     = 0x8410;
  Qwerty_ButtonRound32.Corner_Radius   = 3;
  Qwerty_ButtonRound32.OnUpPtr         = 0;
  Qwerty_ButtonRound32.OnDownPtr       = 0;
  Qwerty_ButtonRound32.OnClickPtr      = Qwerty_ButtonRound32OnClick;
  Qwerty_ButtonRound32.OnPressPtr      = 0;

  Qwerty_ButtonRound33.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound33.Order           = 33;
  Qwerty_ButtonRound33.Left            = 65;
  Qwerty_ButtonRound33.Top             = 169;
  Qwerty_ButtonRound33.Width           = 32;
  Qwerty_ButtonRound33.Height          = 32;
  Qwerty_ButtonRound33.Pen_Width       = 1;
  Qwerty_ButtonRound33.Pen_Color       = 0x0000;
  Qwerty_ButtonRound33.Visible         = 1;
  Qwerty_ButtonRound33.Active          = 1;
  Qwerty_ButtonRound33.Transparent     = 1;
  Qwerty_ButtonRound33.Caption         = Qwerty_ButtonRound33_Caption;
  Qwerty_ButtonRound33.TextAlign       = _taCenter;
  Qwerty_ButtonRound33.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound33.PressColEnabled = 1;
  Qwerty_ButtonRound33.Font_Color      = 0x0000;
  Qwerty_ButtonRound33.Gradient        = 1;
  Qwerty_ButtonRound33.Gradient_Orientation    = 0;
  Qwerty_ButtonRound33.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound33.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound33.Color           = 0xC618;
  Qwerty_ButtonRound33.Press_Color     = 0x8410;
  Qwerty_ButtonRound33.Corner_Radius   = 3;
  Qwerty_ButtonRound33.OnUpPtr         = 0;
  Qwerty_ButtonRound33.OnDownPtr       = 0;
  Qwerty_ButtonRound33.OnClickPtr      = Qwerty_ButtonRound33OnClick;
  Qwerty_ButtonRound33.OnPressPtr      = 0;

  Qwerty_ButtonRound34.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound34.Order           = 34;
  Qwerty_ButtonRound34.Left            = 97;
  Qwerty_ButtonRound34.Top             = 169;
  Qwerty_ButtonRound34.Width           = 32;
  Qwerty_ButtonRound34.Height          = 32;
  Qwerty_ButtonRound34.Pen_Width       = 1;
  Qwerty_ButtonRound34.Pen_Color       = 0x0000;
  Qwerty_ButtonRound34.Visible         = 1;
  Qwerty_ButtonRound34.Active          = 1;
  Qwerty_ButtonRound34.Transparent     = 1;
  Qwerty_ButtonRound34.Caption         = Qwerty_ButtonRound34_Caption;
  Qwerty_ButtonRound34.TextAlign       = _taCenter;
  Qwerty_ButtonRound34.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound34.PressColEnabled = 1;
  Qwerty_ButtonRound34.Font_Color      = 0x0000;
  Qwerty_ButtonRound34.Gradient        = 1;
  Qwerty_ButtonRound34.Gradient_Orientation    = 0;
  Qwerty_ButtonRound34.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound34.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound34.Color           = 0xC618;
  Qwerty_ButtonRound34.Press_Color     = 0x8410;
  Qwerty_ButtonRound34.Corner_Radius   = 3;
  Qwerty_ButtonRound34.OnUpPtr         = 0;
  Qwerty_ButtonRound34.OnDownPtr       = 0;
  Qwerty_ButtonRound34.OnClickPtr      = Qwerty_ButtonRound34OnClick;
  Qwerty_ButtonRound34.OnPressPtr      = 0;

  Qwerty_ButtonRound35.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound35.Order           = 35;
  Qwerty_ButtonRound35.Left            = 129;
  Qwerty_ButtonRound35.Top             = 169;
  Qwerty_ButtonRound35.Width           = 32;
  Qwerty_ButtonRound35.Height          = 32;
  Qwerty_ButtonRound35.Pen_Width       = 1;
  Qwerty_ButtonRound35.Pen_Color       = 0x0000;
  Qwerty_ButtonRound35.Visible         = 1;
  Qwerty_ButtonRound35.Active          = 1;
  Qwerty_ButtonRound35.Transparent     = 1;
  Qwerty_ButtonRound35.Caption         = Qwerty_ButtonRound35_Caption;
  Qwerty_ButtonRound35.TextAlign       = _taCenter;
  Qwerty_ButtonRound35.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound35.PressColEnabled = 1;
  Qwerty_ButtonRound35.Font_Color      = 0x0000;
  Qwerty_ButtonRound35.Gradient        = 1;
  Qwerty_ButtonRound35.Gradient_Orientation    = 0;
  Qwerty_ButtonRound35.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound35.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound35.Color           = 0xC618;
  Qwerty_ButtonRound35.Press_Color     = 0x8410;
  Qwerty_ButtonRound35.Corner_Radius   = 3;
  Qwerty_ButtonRound35.OnUpPtr         = 0;
  Qwerty_ButtonRound35.OnDownPtr       = 0;
  Qwerty_ButtonRound35.OnClickPtr      = Qwerty_ButtonRound35OnClick;
  Qwerty_ButtonRound35.OnPressPtr      = 0;

  Qwerty_ButtonRound36.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound36.Order           = 36;
  Qwerty_ButtonRound36.Left            = 161;
  Qwerty_ButtonRound36.Top             = 169;
  Qwerty_ButtonRound36.Width           = 32;
  Qwerty_ButtonRound36.Height          = 32;
  Qwerty_ButtonRound36.Pen_Width       = 1;
  Qwerty_ButtonRound36.Pen_Color       = 0x0000;
  Qwerty_ButtonRound36.Visible         = 1;
  Qwerty_ButtonRound36.Active          = 1;
  Qwerty_ButtonRound36.Transparent     = 1;
  Qwerty_ButtonRound36.Caption         = Qwerty_ButtonRound36_Caption;
  Qwerty_ButtonRound36.TextAlign       = _taCenter;
  Qwerty_ButtonRound36.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound36.PressColEnabled = 1;
  Qwerty_ButtonRound36.Font_Color      = 0x0000;
  Qwerty_ButtonRound36.Gradient        = 1;
  Qwerty_ButtonRound36.Gradient_Orientation    = 0;
  Qwerty_ButtonRound36.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound36.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound36.Color           = 0xC618;
  Qwerty_ButtonRound36.Press_Color     = 0x8410;
  Qwerty_ButtonRound36.Corner_Radius   = 3;
  Qwerty_ButtonRound36.OnUpPtr         = 0;
  Qwerty_ButtonRound36.OnDownPtr       = 0;
  Qwerty_ButtonRound36.OnClickPtr      = Qwerty_ButtonRound36OnClick;
  Qwerty_ButtonRound36.OnPressPtr      = 0;

  Qwerty_ButtonRound37.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound37.Order           = 37;
  Qwerty_ButtonRound37.Left            = 193;
  Qwerty_ButtonRound37.Top             = 169;
  Qwerty_ButtonRound37.Width           = 32;
  Qwerty_ButtonRound37.Height          = 32;
  Qwerty_ButtonRound37.Pen_Width       = 1;
  Qwerty_ButtonRound37.Pen_Color       = 0x0000;
  Qwerty_ButtonRound37.Visible         = 1;
  Qwerty_ButtonRound37.Active          = 1;
  Qwerty_ButtonRound37.Transparent     = 1;
  Qwerty_ButtonRound37.Caption         = Qwerty_ButtonRound37_Caption;
  Qwerty_ButtonRound37.TextAlign       = _taCenter;
  Qwerty_ButtonRound37.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound37.PressColEnabled = 1;
  Qwerty_ButtonRound37.Font_Color      = 0x0000;
  Qwerty_ButtonRound37.Gradient        = 1;
  Qwerty_ButtonRound37.Gradient_Orientation    = 0;
  Qwerty_ButtonRound37.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound37.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound37.Color           = 0xC618;
  Qwerty_ButtonRound37.Press_Color     = 0x8410;
  Qwerty_ButtonRound37.Corner_Radius   = 3;
  Qwerty_ButtonRound37.OnUpPtr         = 0;
  Qwerty_ButtonRound37.OnDownPtr       = 0;
  Qwerty_ButtonRound37.OnClickPtr      = Qwerty_ButtonRound37OnClick;
  Qwerty_ButtonRound37.OnPressPtr      = 0;

  Qwerty_ButtonRound38.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound38.Order           = 38;
  Qwerty_ButtonRound38.Left            = 225;
  Qwerty_ButtonRound38.Top             = 169;
  Qwerty_ButtonRound38.Width           = 32;
  Qwerty_ButtonRound38.Height          = 32;
  Qwerty_ButtonRound38.Pen_Width       = 1;
  Qwerty_ButtonRound38.Pen_Color       = 0x0000;
  Qwerty_ButtonRound38.Visible         = 1;
  Qwerty_ButtonRound38.Active          = 1;
  Qwerty_ButtonRound38.Transparent     = 1;
  Qwerty_ButtonRound38.Caption         = Qwerty_ButtonRound38_Caption;
  Qwerty_ButtonRound38.TextAlign       = _taCenter;
  Qwerty_ButtonRound38.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound38.PressColEnabled = 1;
  Qwerty_ButtonRound38.Font_Color      = 0x0000;
  Qwerty_ButtonRound38.Gradient        = 1;
  Qwerty_ButtonRound38.Gradient_Orientation    = 0;
  Qwerty_ButtonRound38.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound38.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound38.Color           = 0xC618;
  Qwerty_ButtonRound38.Press_Color     = 0x8410;
  Qwerty_ButtonRound38.Corner_Radius   = 3;
  Qwerty_ButtonRound38.OnUpPtr         = 0;
  Qwerty_ButtonRound38.OnDownPtr       = 0;
  Qwerty_ButtonRound38.OnClickPtr      = Qwerty_ButtonRound38OnClick;
  Qwerty_ButtonRound38.OnPressPtr      = 0;

  Qwerty_ButtonRound39.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound39.Order           = 39;
  Qwerty_ButtonRound39.Left            = 257;
  Qwerty_ButtonRound39.Top             = 169;
  Qwerty_ButtonRound39.Width           = 32;
  Qwerty_ButtonRound39.Height          = 32;
  Qwerty_ButtonRound39.Pen_Width       = 1;
  Qwerty_ButtonRound39.Pen_Color       = 0x0000;
  Qwerty_ButtonRound39.Visible         = 1;
  Qwerty_ButtonRound39.Active          = 1;
  Qwerty_ButtonRound39.Transparent     = 1;
  Qwerty_ButtonRound39.Caption         = Qwerty_ButtonRound39_Caption;
  Qwerty_ButtonRound39.TextAlign       = _taCenter;
  Qwerty_ButtonRound39.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound39.PressColEnabled = 1;
  Qwerty_ButtonRound39.Font_Color      = 0x0000;
  Qwerty_ButtonRound39.Gradient        = 1;
  Qwerty_ButtonRound39.Gradient_Orientation    = 0;
  Qwerty_ButtonRound39.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound39.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound39.Color           = 0xC618;
  Qwerty_ButtonRound39.Press_Color     = 0x8410;
  Qwerty_ButtonRound39.Corner_Radius   = 3;
  Qwerty_ButtonRound39.OnUpPtr         = 0;
  Qwerty_ButtonRound39.OnDownPtr       = 0;
  Qwerty_ButtonRound39.OnClickPtr      = Qwerty_ButtonRound39OnClick;
  Qwerty_ButtonRound39.OnPressPtr      = 0;

  Qwerty_ButtonRound40.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound40.Order           = 40;
  Qwerty_ButtonRound40.Left            = 289;
  Qwerty_ButtonRound40.Top             = 169;
  Qwerty_ButtonRound40.Width           = 32;
  Qwerty_ButtonRound40.Height          = 32;
  Qwerty_ButtonRound40.Pen_Width       = 1;
  Qwerty_ButtonRound40.Pen_Color       = 0x0000;
  Qwerty_ButtonRound40.Visible         = 1;
  Qwerty_ButtonRound40.Active          = 1;
  Qwerty_ButtonRound40.Transparent     = 1;
  Qwerty_ButtonRound40.Caption         = Qwerty_ButtonRound40_Caption;
  Qwerty_ButtonRound40.TextAlign       = _taCenter;
  Qwerty_ButtonRound40.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound40.PressColEnabled = 1;
  Qwerty_ButtonRound40.Font_Color      = 0x0000;
  Qwerty_ButtonRound40.Gradient        = 1;
  Qwerty_ButtonRound40.Gradient_Orientation    = 0;
  Qwerty_ButtonRound40.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound40.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound40.Color           = 0xC618;
  Qwerty_ButtonRound40.Press_Color     = 0x8410;
  Qwerty_ButtonRound40.Corner_Radius   = 3;
  Qwerty_ButtonRound40.OnUpPtr         = 0;
  Qwerty_ButtonRound40.OnDownPtr       = 0;
  Qwerty_ButtonRound40.OnClickPtr      = Qwerty_ButtonRound40OnClick;
  Qwerty_ButtonRound40.OnPressPtr      = 0;

  Qwerty_ButtonRound41.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound41.Order           = 41;
  Qwerty_ButtonRound41.Left            = 1;
  Qwerty_ButtonRound41.Top             = 201;
  Qwerty_ButtonRound41.Width           = 64;
  Qwerty_ButtonRound41.Height          = 32;
  Qwerty_ButtonRound41.Pen_Width       = 1;
  Qwerty_ButtonRound41.Pen_Color       = 0x0000;
  Qwerty_ButtonRound41.Visible         = 1;
  Qwerty_ButtonRound41.Active          = 1;
  Qwerty_ButtonRound41.Transparent     = 1;
  Qwerty_ButtonRound41.Caption         = Qwerty_ButtonRound41_Caption;
  Qwerty_ButtonRound41.TextAlign       = _taCenter;
  Qwerty_ButtonRound41.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound41.PressColEnabled = 1;
  Qwerty_ButtonRound41.Font_Color      = 0x0000;
  Qwerty_ButtonRound41.Gradient        = 1;
  Qwerty_ButtonRound41.Gradient_Orientation    = 0;
  Qwerty_ButtonRound41.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound41.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound41.Color           = 0xC618;
  Qwerty_ButtonRound41.Press_Color     = 0x8410;
  Qwerty_ButtonRound41.Corner_Radius   = 3;
  Qwerty_ButtonRound41.OnUpPtr         = 0;
  Qwerty_ButtonRound41.OnDownPtr       = 0;
  Qwerty_ButtonRound41.OnClickPtr      = Qwerty_ButtonRound41OnClick;
  Qwerty_ButtonRound41.OnPressPtr      = 0;

  Qwerty_ButtonRound42.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound42.Order           = 42;
  Qwerty_ButtonRound42.Left            = 65;
  Qwerty_ButtonRound42.Top             = 201;
  Qwerty_ButtonRound42.Width           = 128;
  Qwerty_ButtonRound42.Height          = 32;
  Qwerty_ButtonRound42.Pen_Width       = 1;
  Qwerty_ButtonRound42.Pen_Color       = 0x0000;
  Qwerty_ButtonRound42.Visible         = 1;
  Qwerty_ButtonRound42.Active          = 1;
  Qwerty_ButtonRound42.Transparent     = 1;
  Qwerty_ButtonRound42.Caption         = Qwerty_ButtonRound42_Caption;
  Qwerty_ButtonRound42.TextAlign       = _taCenter;
  Qwerty_ButtonRound42.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound42.PressColEnabled = 1;
  Qwerty_ButtonRound42.Font_Color      = 0x0000;
  Qwerty_ButtonRound42.Gradient        = 1;
  Qwerty_ButtonRound42.Gradient_Orientation    = 0;
  Qwerty_ButtonRound42.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound42.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound42.Color           = 0xC618;
  Qwerty_ButtonRound42.Press_Color     = 0x8410;
  Qwerty_ButtonRound42.Corner_Radius   = 3;
  Qwerty_ButtonRound42.OnUpPtr         = 0;
  Qwerty_ButtonRound42.OnDownPtr       = 0;
  Qwerty_ButtonRound42.OnClickPtr      = Qwerty_ButtonRound42OnClick;
  Qwerty_ButtonRound42.OnPressPtr      = 0;

  Qwerty_ButtonRound43.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound43.Order           = 43;
  Qwerty_ButtonRound43.Left            = 193;
  Qwerty_ButtonRound43.Top             = 201;
  Qwerty_ButtonRound43.Width           = 64;
  Qwerty_ButtonRound43.Height          = 32;
  Qwerty_ButtonRound43.Pen_Width       = 1;
  Qwerty_ButtonRound43.Pen_Color       = 0x0000;
  Qwerty_ButtonRound43.Visible         = 1;
  Qwerty_ButtonRound43.Active          = 1;
  Qwerty_ButtonRound43.Transparent     = 1;
  Qwerty_ButtonRound43.Caption         = Qwerty_ButtonRound43_Caption;
  Qwerty_ButtonRound43.TextAlign       = _taCenter;
  Qwerty_ButtonRound43.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound43.PressColEnabled = 1;
  Qwerty_ButtonRound43.Font_Color      = 0x0000;
  Qwerty_ButtonRound43.Gradient        = 1;
  Qwerty_ButtonRound43.Gradient_Orientation    = 0;
  Qwerty_ButtonRound43.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound43.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound43.Color           = 0xC618;
  Qwerty_ButtonRound43.Press_Color     = 0x8410;
  Qwerty_ButtonRound43.Corner_Radius   = 3;
  Qwerty_ButtonRound43.OnUpPtr         = 0;
  Qwerty_ButtonRound43.OnDownPtr       = 0;
  Qwerty_ButtonRound43.OnClickPtr      = Qwerty_ButtonRound43OnClick;
  Qwerty_ButtonRound43.OnPressPtr      = 0;

  Qwerty_ButtonRound44.OwnerScreen     = &Screen2;
  Qwerty_ButtonRound44.Order           = 44;
  Qwerty_ButtonRound44.Left            = 257;
  Qwerty_ButtonRound44.Top             = 201;
  Qwerty_ButtonRound44.Width           = 64;
  Qwerty_ButtonRound44.Height          = 32;
  Qwerty_ButtonRound44.Pen_Width       = 1;
  Qwerty_ButtonRound44.Pen_Color       = 0x0000;
  Qwerty_ButtonRound44.Visible         = 1;
  Qwerty_ButtonRound44.Active          = 1;
  Qwerty_ButtonRound44.Transparent     = 1;
  Qwerty_ButtonRound44.Caption         = Qwerty_ButtonRound44_Caption;
  Qwerty_ButtonRound44.TextAlign       = _taCenter;
  Qwerty_ButtonRound44.FontName        = Tahoma11x13_Regular;
  Qwerty_ButtonRound44.PressColEnabled = 1;
  Qwerty_ButtonRound44.Font_Color      = 0x0000;
  Qwerty_ButtonRound44.Gradient        = 1;
  Qwerty_ButtonRound44.Gradient_Orientation    = 0;
  Qwerty_ButtonRound44.Gradient_Start_Color    = 0x8410;
  Qwerty_ButtonRound44.Gradient_End_Color      = 0xC618;
  Qwerty_ButtonRound44.Color           = 0xC618;
  Qwerty_ButtonRound44.Press_Color     = 0x8410;
  Qwerty_ButtonRound44.Corner_Radius   = 3;
  Qwerty_ButtonRound44.OnUpPtr         = 0;
  Qwerty_ButtonRound44.OnDownPtr       = 0;
  Qwerty_ButtonRound44.OnClickPtr      = Qwerty_ButtonRound44OnClick;
  Qwerty_ButtonRound44.OnPressPtr      = 0;

  Qwerty_Label1.OwnerScreen     = &Screen2;
  Qwerty_Label1.Order           = 45;
  Qwerty_Label1.Left            = 7;
  Qwerty_Label1.Top             = 37;
  Qwerty_Label1.Width           = 0;
  Qwerty_Label1.Height          = 15;
  Qwerty_Label1.Visible         = 1;
  Qwerty_Label1.Active          = 1;
  Qwerty_Label1.Caption         = Qwerty_Label1_Caption;
  Qwerty_Label1.FontName        = Tahoma11x13_Regular;
  Qwerty_Label1.Font_Color      = 0x0000;
  Qwerty_Label1.OnUpPtr         = 0;
  Qwerty_Label1.OnDownPtr       = 0;
  Qwerty_Label1.OnClickPtr      = 0;
  Qwerty_Label1.OnPressPtr      = 0;

  Qwerty_Label2.OwnerScreen     = &Screen2;
  Qwerty_Label2.Order           = 46;
  Qwerty_Label2.Left            = 7;
  Qwerty_Label2.Top             = 10;
  Qwerty_Label2.Width           = 77;
  Qwerty_Label2.Height          = 15;
  Qwerty_Label2.Visible         = 1;
  Qwerty_Label2.Active          = 1;
  Qwerty_Label2.Caption         = Qwerty_Label2_Caption;
  Qwerty_Label2.FontName        = Tahoma11x13_Regular;
  Qwerty_Label2.Font_Color      = 0x0000;
  Qwerty_Label2.OnUpPtr         = 0;
  Qwerty_Label2.OnDownPtr       = 0;
  Qwerty_Label2.OnClickPtr      = 0;
  Qwerty_Label2.OnPressPtr      = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetRoundButton(index)         CurrentScreen->Buttons_Round[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetImage(index)               CurrentScreen->Images[index]
#define GetBox(index)                 CurrentScreen->Boxes[index]
#define GetBox_Round(index)           CurrentScreen->Boxes_Round[index]
#define GetLine(index)                CurrentScreen->Lines[index]


void DrawRoundButton(TButton_Round *Around_button) {
    if (Around_button->Visible == 1) {
      if (object_pressed == 1) {
        object_pressed = 0;
        TFT_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                      Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
      }
      else {
        TFT_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
                      Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
      }
      TFT_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
      TFT_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
        Around_button->Left + Around_button->Width - 2,
        Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
      TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL);
      TFT_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
      if (Around_button->TextAlign == _taLeft)
        TFT_Write_Text(Around_button->Caption, Around_button->Left + 4, (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
      else if (Around_button->TextAlign == _taCenter)
        TFT_Write_Text(Around_button->Caption, (Around_button->Left + (Around_button->Width - caption_length) / 2), (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
      else if (Around_button->TextAlign == _taRight)
        TFT_Write_Text(Around_button->Caption, Around_button->Left + (Around_button->Width - caption_length - 4), (Around_button->Top + (Around_button->Height - caption_height) / 2));
    }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible == 1) {
    TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage(TImage *AImage) {
  if (AImage->Visible) {
    TFT_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
  }
}

void DrawBox(TBox *ABox) {
  if (ABox->Visible == 1) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(ABox->Transparent, ABox->Press_Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_End_Color, ABox->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(ABox->Transparent, ABox->Color, ABox->Gradient, ABox->Gradient_Orientation, ABox->Gradient_Start_Color, ABox->Gradient_End_Color);
    }
    TFT_Set_Pen(ABox->Pen_Color, ABox->Pen_Width);
    TFT_Rectangle(ABox->Left, ABox->Top, ABox->Left + ABox->Width - 1, ABox->Top + ABox->Height - 1);
  }
}

void DrawRoundBox(TBox_Round *Around_box) {
    if (Around_box->Visible == 1) {
      if (object_pressed == 1) {
        object_pressed = 0;
        TFT_Set_Brush(Around_box->Transparent, Around_box->Press_Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                      Around_box->Gradient_End_Color, Around_box->Gradient_Start_Color);
      }
      else {
        TFT_Set_Brush(Around_box->Transparent, Around_box->Color, Around_box->Gradient, Around_box->Gradient_Orientation,
                      Around_box->Gradient_Start_Color, Around_box->Gradient_End_Color);
      }
      TFT_Set_Pen(Around_box->Pen_Color, Around_box->Pen_Width);
      TFT_Rectangle_Round_Edges(Around_box->Left + 1, Around_box->Top + 1,
        Around_box->Left + Around_box->Width - 2,
        Around_box->Top + Around_box->Height - 2, Around_box->Corner_Radius);
    }
}

void DrawLine(TLine *Aline) {
  if (Aline->Visible == 1) {
    TFT_Set_Pen(Aline->Color, Aline->Pen_Width);
    TFT_Line(Aline->First_Point_X, Aline->First_Point_Y, Aline->Second_Point_X, Aline->Second_Point_Y);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short round_button_idx;
  TButton_Round *local_round_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  unsigned short box_idx;
  TBox *local_box;
  unsigned short round_box_idx;
  TBox_Round *local_round_box;
  unsigned short line_idx;
  TLine *local_line;
  char save_bled, save_bled_direction;

  object_pressed = 0;
  order = 0;
  round_button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  box_idx = 0;
  round_box_idx = 0;
  line_idx = 0;
  CurrentScreen = aScreen;

  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    save_bled_direction = TFT_BLED_Direction;
    TFT_BLED_Direction = 1;
    TFT_BLED           = 0;
    TFT_Init(CurrentScreen->Width, CurrentScreen->Height);
    TP_TFT_Init(CurrentScreen->Width, CurrentScreen->Height, 11, 10);                                  // Initialize touch panel
    TP_TFT_Set_ADC_Threshold(ADC_THRESHOLD);                              // Set touch panel ADC threshold
    TFT_Fill_Screen(CurrentScreen->Color);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
    TFT_BLED_Direction = save_bled_direction;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
      local_round_button = GetRoundButton(round_button_idx);
      if (order == local_round_button->Order) {
        order++;
        round_button_idx++;
        DrawRoundButton(local_round_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (box_idx < CurrentScreen->BoxesCount) {
      local_box = GetBox(box_idx);
      if (order == local_box->Order) {
        box_idx++;
        order++;
        DrawBox(local_box);
      }
    }

    if (round_box_idx < CurrentScreen->Boxes_RoundCount) {
      local_round_box = GetBox_Round(round_box_idx);
      if (order == local_round_box->Order) {
        round_box_idx++;
        order++;
        DrawRoundBox(local_round_box);
      }
    }

    if (line_idx  < CurrentScreen->LinesCount) {
      local_line = GetLine(line_idx);
      if (order == local_line->Order) {
        line_idx++;
        order++;
        DrawLine(local_line);
      }
    }

    if (image_idx  < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
    }

  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  round_button_order  = -1;
  label_order         = -1;
  image_order         = -1;
  box_order           = -1;
  box_round_order     = -1;
  //  Buttons with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
    local_round_button = GetRoundButton(_object_count);
    if (local_round_button->Active == 1) {
      if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
                         local_round_button->Width, local_round_button->Height) == 1) {
        round_button_order = local_round_button->Order;
        exec_round_button = local_round_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active == 1) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Images
  for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
    local_image = GetImage(_object_count);
    if (local_image->Active == 1) {
      if (IsInsideObject(X, Y, local_image->Left, local_image->Top,
                         local_image->Width, local_image->Height) == 1) {
        image_order = local_image->Order;
        exec_image = local_image;
      }
    }
  }

  //  Boxes
  for ( _object_count = 0 ; _object_count < CurrentScreen->BoxesCount ; _object_count++ ) {
    local_box = GetBox(_object_count);
    if (local_box->Active == 1) {
      if (IsInsideObject(X, Y, local_box->Left, local_box->Top,
                         local_box->Width, local_box->Height) == 1) {
        box_order = local_box->Order;
        exec_box = local_box;
      }
    }
  }

  //  Boxes with Round Edges
  for ( _object_count = 0 ; _object_count < CurrentScreen->Boxes_RoundCount ; _object_count++ ) {
    local_round_box = GetBox_Round(_object_count);
    if (local_round_box->Active == 1) {
      if (IsInsideObject(X, Y, local_round_box->Left, local_round_box->Top,
                         local_round_box->Width, local_round_box->Height) == 1) {
        box_round_order = local_round_box->Order;
        exec_round_box = local_round_box;
      }
    }
  }

  _object_count = -1;
  if (round_button_order > _object_count)
    _object_count = round_button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (image_order >  _object_count )
    _object_count = image_order;
  if (box_order >  _object_count )
    _object_count = box_order;
  if (box_round_order >  _object_count )
    _object_count = box_round_order;
}


static void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_round_button   = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_box            = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnPressPtr != 0) {
          exec_round_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active == 1) {
        if (exec_image->OnPressPtr != 0) {
          exec_image->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnPressPtr != 0) {
          exec_box->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active == 1) {
        if (exec_round_box->OnPressPtr != 0) {
          exec_round_box->OnPressPtr();
          return;
        }
      }
    }

  }
}

static void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Round Button
    case 1: {
      if (PressedObject != 0) {
        exec_round_button = (TButton_Round*)PressedObject;
        if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
          DrawRoundButton(exec_round_button);
        }
        break;
      }
      break;
    }
    // Box
    case 6: {
      if (PressedObject != 0) {
        exec_box = (TBox*)PressedObject;
        if ((exec_box->PressColEnabled == 1) && (exec_box->OwnerScreen == CurrentScreen)) {
          DrawBox(exec_box);
        }
        break;
      }
      break;
    }
    // Round Box
    case 7: {
      if (PressedObject != 0) {
        exec_round_box = (TBox_Round*)PressedObject;
        if ((exec_round_box->PressColEnabled == 1) && (exec_round_box->OwnerScreen == CurrentScreen)) {
          DrawRoundBox(exec_round_box);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons with Round Edges
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->OnUpPtr != 0)
          exec_round_button->OnUpPtr();
        if (PressedObject == (void *)exec_round_button)
          if (exec_round_button->OnClickPtr != 0)
            exec_round_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Images
    if (_object_count == image_order) {
      if (exec_image->Active == 1) {
        if (exec_image->OnUpPtr != 0)
          exec_image->OnUpPtr();
        if (PressedObject == (void *)exec_image)
          if (exec_image->OnClickPtr != 0)
            exec_image->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes
    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->OnUpPtr != 0)
          exec_box->OnUpPtr();
        if (PressedObject == (void *)exec_box)
          if (exec_box->OnClickPtr != 0)
            exec_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Boxes with Round Edges
    if (_object_count == box_round_order) {
      if (exec_round_box->Active == 1) {
        if (exec_round_box->OnUpPtr != 0)
          exec_round_box->OnUpPtr();
        if (PressedObject == (void *)exec_round_box)
          if (exec_round_box->OnClickPtr != 0)
            exec_round_box->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

static void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_round_button   = 0;
  exec_label          = 0;
  exec_image          = 0;
  exec_box            = 0;
  exec_round_box      = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == round_button_order) {
      if (exec_round_button->Active == 1) {
        if (exec_round_button->PressColEnabled == 1) {
          object_pressed = 1;
          DrawRoundButton(exec_round_button);
        }
        PressedObject = (void *)exec_round_button;
        PressedObjectType = 1;
        if (exec_round_button->OnDownPtr != 0) {
          exec_round_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active == 1) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active == 1) {
        PressedObject = (void *)exec_image;
        PressedObjectType = 3;
        if (exec_image->OnDownPtr != 0) {
          exec_image->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_order) {
      if (exec_box->Active == 1) {
        if (exec_box->PressColEnabled == 1) {
          object_pressed = 1;
          DrawBox(exec_box);
        }
        PressedObject = (void *)exec_box;
        PressedObjectType = 6;
        if (exec_box->OnDownPtr != 0) {
          exec_box->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == box_round_order) {
      if (exec_round_box->Active == 1) {
        if (exec_round_box->PressColEnabled == 1) {
          object_pressed = 1;
          DrawRoundBox(exec_round_box);
        }
        PressedObject = (void *)exec_round_box;
        PressedObjectType = 7;
        if (exec_round_box->OnDownPtr != 0) {
          exec_round_box->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (TP_TFT_Press_Detect()) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
    if (TP_TFT_Get_Coordinates(&Xcoord, &Ycoord) == 0) {
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU(){
  GPIO_Config(&GPIO_PORTD_DATA_BITS, 0b00001000, _GPIO_DIR_OUTPUT, _GPIO_CFG_DIGITAL_ENABLE | _GPIO_CFG_DRIVE_8mA, 0);
  TFT_BLED = 1;
  TFT_Set_Default_Mode();
  TP_TFT_Set_Default_Mode();
}

void Start_TP() {
  Init_MCU();

  InitializeTouchPanel();

  // You can get calibration constants using touch panel calibration example
  TP_TFT_Set_Calibration_Consts(69, 925, 64, 917);    // Set calibration constants

  InitializeObjects();
  display_width = Screen1.Width;
  display_height = Screen1.Height;
  DrawScreen(&Screen1);
}
