#include "WiFiTEst_objects.h"
#include "WiFiTEst_resources.h"

//--------------------- User code ---------------------//
#include "UART0.h"
#include "WiFiPlus.h"
#include "USB_Driver.h"
#include "Common.h"

// Variables
char SaveLabelCaption[24];
char TempMsg[24];
char CaptionBuf[64];
char ShiftState = FALSE;

extern tPointerFcn WiFiStateFuncPtr;
extern char myPassword[20];
extern char mySSID[32];

// Label functions *************************************************************
void ClearLbl( TLabel *_label) {
     TFT_Set_Font(_label->FontName, Box1.Color, FO_HORIZONTAL);
     TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void ClearLabel( TLabel *_label) {
     ClearLbl(_label);
     strcpy(_label->Caption, "");
}

void DrawLbl( TLabel *_label) {
     TFT_Set_Font(_label->FontName, _label->Font_Color, FO_HORIZONTAL);
     TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void DrawBlueLabel( TLabel *_label) {
     _label->Font_Color = CL_BLUE;
     DrawLbl(_label);
}

void DrawBlackLabel( TLabel *_label) {
     _label->Font_Color = CL_BLACK;
     DrawLbl(_label);
}

void RestoreLabelColor(void) {
     DrawBlackLabel(&Label4);
     DrawBlackLabel(&Label7);
     DrawBlackLabel(&Label10);
     DrawBlackLabel(&Label13);
     DrawBlackLabel(&Label16);
}

void ClearAllLabels(void) {
     ClearLabel(&Label4);
     ClearLabel(&Label5);
     ClearLabel(&Label6);
     ClearLabel(&Label7);
     ClearLabel(&Label8);
     ClearLabel(&Label9);
     ClearLabel(&Label10);
     ClearLabel(&Label11);
     ClearLabel(&Label12);
     ClearLabel(&Label13);
     ClearLabel(&Label14);
     ClearLabel(&Label15);
     ClearLabel(&Label16);
     ClearLabel(&Label17);
     ClearLabel(&Label18);
}

void UpdateLabel4(char *msg) {
     ClearLabel(&Label4);
     if (strlen(msg)<=20) strcpy(Label4.Caption,msg);
     else strcpy(Label4.Caption,"SSID too long");
     DrawLbl(&Label4);
}

void UpdateLabel5(char *msg) {
     ClearLabel(&Label5);
     if (strlen(msg)<=6) strcpy(Label5.Caption,msg);
     else strcpy(Label5.Caption,"---");
     DrawLbl(&Label5);
}

void UpdateLabel6(char *msg) {
     ClearLabel(&Label6);
     if (strlen(msg)<=3) strcpy(Label6.Caption,msg);
     else strcpy(Label6.Caption,"---");
     DrawLbl(&Label6);
}

void UpdateLabel7(char *msg) {
     ClearLabel(&Label7);
     if (strlen(msg)<=20) strcpy(Label7.Caption,msg);
     else strcpy(Label7.Caption,"SSID too long");
     DrawLbl(&Label7);
}

void UpdateLabel8(char *msg) {
     ClearLabel(&Label8);
     if (strlen(msg)<=6) strcpy(Label8.Caption,msg);
     else strcpy(Label8.Caption,"---");
     DrawLbl(&Label8);
}

void UpdateLabel9(char *msg) {
     ClearLabel(&Label9);
     if (strlen(msg)<=3) strcpy(Label9.Caption,msg);
     else strcpy(Label9.Caption,"---");
     DrawLbl(&Label9);
}

void UpdateLabel10(char *msg) {
     ClearLabel(&Label10);
     if (strlen(msg)<=20) strcpy(Label10.Caption,msg);
     else strcpy(Label10.Caption,"SSID too long");
     DrawLbl(&Label10);
}

void UpdateLabel11(char *msg) {
     ClearLabel(&Label11);
     if (strlen(msg)<=6) strcpy(Label11.Caption,msg);
     else strcpy(Label11.Caption,"---");
     DrawLbl(&Label11);
}

void UpdateLabel12(char *msg) {
     ClearLabel(&Label12);
     if (strlen(msg)<=3) strcpy(Label12.Caption,msg);
     else strcpy(Label12.Caption,"---");
     DrawLbl(&Label12);
}

void UpdateLabel13(char *msg) {
     ClearLabel(&Label13);
     if (strlen(msg)<=20) strcpy(Label13.Caption,msg);
     else strcpy(Label13.Caption,"SSID too long");
     DrawLbl(&Label13);
}

void UpdateLabel14(char *msg) {
     ClearLabel(&Label14);
     if (strlen(msg)<=6) strcpy(Label14.Caption,msg);
     else strcpy(Label14.Caption,"---");
     DrawLbl(&Label14);
}

void UpdateLabel15(char *msg) {
     ClearLabel(&Label15);
     if (strlen(msg)<=3) strcpy(Label15.Caption,msg);
     else strcpy(Label15.Caption,"---");
     DrawLbl(&Label15);
}

void UpdateLabel16(char *msg) {
     ClearLabel(&Label16);
     if (strlen(msg)<=20) strcpy(Label16.Caption,msg);
     else strcpy(Label16.Caption,"SSID too long");
     DrawLbl(&Label16);
}

void UpdateLabel17(char *msg) {
     ClearLabel(&Label17);
     if (strlen(msg)<=6) strcpy(Label17.Caption,msg);
     else strcpy(Label17.Caption,"---");
     DrawLbl(&Label17);
}

void UpdateLabel18(char *msg) {
     ClearLabel(&Label18);
     if (strlen(msg)<=3) strcpy(Label18.Caption,msg);
     else strcpy(Label18.Caption,"---");
     DrawLbl(&Label18);
}

void UpdateLabel19(char *msg, unsigned int Color) {
     ClearLabel(&Label19);
     if (strlen(msg)<=30) {
         strcpy(Label19.Caption,msg);
         Label19.Font_Color = Color;
         DrawLbl(&Label19);
     }
}

// Button functions ************************************************************
void EnableButton2(void) {
     ButtonRound2.Visible = TRUE;
     DrawRoundButton(&ButtonRound2);
}

void EnableButton3(void) {
     ButtonRound3.Visible = TRUE;
     DrawRoundButton(&ButtonRound3);
}

void EnableButton4(void) {
     ButtonRound4.Visible = TRUE;
     DrawRoundButton(&ButtonRound4);
}

void EraseButton2(void) {
     int x1, y1, x2, y2;
     
     ButtonRound2.Visible = FALSE;
     x1 = ButtonRound2.Left;
     y1 = ButtonRound2.Top;
     x2 = x1 + ButtonRound2.Width;
     y2 = y1 + ButtonRound2.Height;
     TFT_Set_Pen(CL_TEAL, 1);
     TFT_Set_Brush(1, CL_TEAL, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
     TFT_Rectangle(x1,y1,x2,y2);
     DrawRoundButton(&ButtonRound2);
}

void EraseButton3(void) {
     int x1, y1, x2, y2;
     
     ButtonRound3.Visible = FALSE;
     x1 = ButtonRound3.Left;
     y1 = ButtonRound3.Top;
     x2 = x1 + ButtonRound3.Width;
     y2 = y1 + ButtonRound3.Height;
     TFT_Set_Pen(CL_TEAL, 1);
     TFT_Set_Brush(1, CL_TEAL, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
     TFT_Rectangle(x1,y1,x2,y2);
     DrawRoundButton(&ButtonRound3);
}

void EraseButton4(void) {
     int x1, y1, x2, y2;
     
     ButtonRound4.Visible = FALSE;
     x1 = ButtonRound4.Left;
     y1 = ButtonRound4.Top;
     x2 = x1 + ButtonRound4.Width;
     y2 = y1 + ButtonRound4.Height;
     TFT_Set_Pen(CL_TEAL, 1);
     TFT_Set_Brush(1, CL_TEAL, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
     TFT_Rectangle(x1,y1,x2,y2);
     DrawRoundButton(&ButtonRound4);
}

// Qwerty keyboard functions ***************************************************
void Qwerty_ClearLbl( TLabel *_label) {
     TFT_Set_Font(_label->FontName, Qwerty_BoxRound1.Color, FO_HORIZONTAL);
     TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void Qwerty_ClearLabel( TLabel *_label) {
     Qwerty_ClearLbl(_label);
     strcpy(_label->Caption, "");
}

void Qwerty_DrawLbl( TLabel *_label) {
     TFT_Set_Font(_label->FontName, _label->Font_Color, FO_HORIZONTAL);
     TFT_Write_Text(_label->Caption, _label->Left, _label->Top);
}

void Qwerty_UpdateLabel1(char *msg) {
     strcpy(CaptionBuf,Qwerty_Label1.Caption);
     
     if (strlen(CaptionBuf) < 51) {
         ClearLabel(&Qwerty_Label1);
         strcat(CaptionBuf,msg);
         strcpy(Qwerty_Label1.Caption,CaptionBuf);
         DrawLbl(&Qwerty_Label1);
     }
}



//----------------- End of User code ------------------//

// Event Handlers

void Label4OnClick() {           // These LabelOnClick events don't work so well
     RestoreLabelColor();
     DrawBlueLabel(&Label4);
     strcpy(mySSID,Label4.Caption);
}

void Label7OnClick() {
     RestoreLabelColor();
     DrawBlueLabel(&Label7);
     strcpy(mySSID,Label7.Caption);
}

void Label10OnClick() {
     RestoreLabelColor();
     DrawBlueLabel(&Label10);
     strcpy(mySSID,Label10.Caption);
}

void Label13OnClick() {
     RestoreLabelColor();
     DrawBlueLabel(&Label13);
     strcpy(mySSID,Label13.Caption);
}

void Label16OnClick() {
     RestoreLabelColor();
     DrawBlueLabel(&Label16);
     strcpy(mySSID,Label16.Caption);
}

void ButtonRound1OnClick() { // Scan button
     RestoreLabelColor();
     EraseButton2();
     EraseButton3();
     EraseButton4();
     UpdateLabel19("",CL_BLACK);
     WiFiStateFuncPtr = WiFiState90;
}

void ButtonRound2OnClick() { // Connect button
#if USE_PASSWORD == TRUE
     if ((Label4.Font_Color == CL_BLUE) || (Label7.Font_Color == CL_BLUE) ||
         (Label10.Font_Color == CL_BLUE) || (Label13.Font_Color == CL_BLUE) ||
         (Label16.Font_Color == CL_BLUE)) {
         UpdateLabel19("",CL_BLACK);
         Qwerty_ClearLabel(&Qwerty_Label1);  // Clear old password
         DrawScreen(&Screen2); // Get a password from the user (continue at qwerty enter key)
     }else{
         UpdateLabel19("Select SSID",CL_RED);
     }
#else
     WiFiStateFuncPtr = WiFiState100; // Use pre-set SSID and 32-bit security key
#endif
}

void ButtonRound3OnClick() { // Start UDP button
     WiFiStateFuncPtr = WiFiState120;
}

void ButtonRound4OnClick() { // Disconnect button
     WiFiStateFuncPtr = WiFiState130;
}



// Qwerty keyboard *************************************************************


void Qwerty_ButtonRound1OnClick() {
     Qwerty_UpdateLabel1("1");
}

void Qwerty_ButtonRound2OnClick() {
     Qwerty_UpdateLabel1("2");
}

void Qwerty_ButtonRound3OnClick() {
     Qwerty_UpdateLabel1("3");
}

void Qwerty_ButtonRound4OnClick() {
     Qwerty_UpdateLabel1("4");
}

void Qwerty_ButtonRound5OnClick() {
     Qwerty_UpdateLabel1("5");
}

void Qwerty_ButtonRound6OnClick() {
     Qwerty_UpdateLabel1("6");
}

void Qwerty_ButtonRound7OnClick() {
     Qwerty_UpdateLabel1("7");
}

void Qwerty_ButtonRound8OnClick() {
     Qwerty_UpdateLabel1("8");
}

void Qwerty_ButtonRound9OnClick() {
     Qwerty_UpdateLabel1("9");
}

void Qwerty_ButtonRound10OnClick() {
     Qwerty_UpdateLabel1("0");
}

void Qwerty_ButtonRound11OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("q");
     } else {
         Qwerty_UpdateLabel1("Q");
     }
}

void Qwerty_ButtonRound12OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("w");
     } else {
         Qwerty_UpdateLabel1("W");
     }
}

void Qwerty_ButtonRound13OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("e");
     } else {
         Qwerty_UpdateLabel1("E");
     }
}

void Qwerty_ButtonRound14OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("r");
     } else {
         Qwerty_UpdateLabel1("R");
     }
}

void Qwerty_ButtonRound15OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("t");
     } else {
         Qwerty_UpdateLabel1("T");
     }
}

void Qwerty_ButtonRound16OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("y");
     } else {
         Qwerty_UpdateLabel1("Y");
     }
}

void Qwerty_ButtonRound17OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("u");
     } else {
         Qwerty_UpdateLabel1("U");
     }
}

void Qwerty_ButtonRound18OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("i");
     } else {
         Qwerty_UpdateLabel1("I");
     }
}

void Qwerty_ButtonRound19OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("o");
     } else {
         Qwerty_UpdateLabel1("O");
     }
}

void Qwerty_ButtonRound20OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("p");
     } else {
         Qwerty_UpdateLabel1("P");
     }
}

void Qwerty_ButtonRound21OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("a");
     } else {
         Qwerty_UpdateLabel1("A");
     }
}

void Qwerty_ButtonRound22OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("s");
     } else {
         Qwerty_UpdateLabel1("S");
     }
}

void Qwerty_ButtonRound23OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("d");
     } else {
         Qwerty_UpdateLabel1("D");
     }
}

void Qwerty_ButtonRound24OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("f");
     } else {
         Qwerty_UpdateLabel1("F");
     }
}

void Qwerty_ButtonRound25OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("g");
     } else {
         Qwerty_UpdateLabel1("G");
     }
}

void Qwerty_ButtonRound26OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("h");
     } else {
         Qwerty_UpdateLabel1("H");
     }
}

void Qwerty_ButtonRound27OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("j");
     } else {
         Qwerty_UpdateLabel1("J");
     }
}

void Qwerty_ButtonRound28OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("k");
     } else {
         Qwerty_UpdateLabel1("K");
     }
}

void Qwerty_ButtonRound29OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("l");
     } else {
         Qwerty_UpdateLabel1("L");
     }
}

void Qwerty_ButtonRound30OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1(":");
     } else {
         Qwerty_UpdateLabel1(":");
     }
}

void Qwerty_ButtonRound31OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("z");
     } else {
         Qwerty_UpdateLabel1("Z");
     }
}

void Qwerty_ButtonRound32OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("x");
     } else {
         Qwerty_UpdateLabel1("X");
     }
}

void Qwerty_ButtonRound33OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("c");
     } else {
         Qwerty_UpdateLabel1("C");
     }
}

void Qwerty_ButtonRound34OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("v");
     } else {
         Qwerty_UpdateLabel1("V");
     }
}

void Qwerty_ButtonRound35OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("b");
     } else {
         Qwerty_UpdateLabel1("B");
     }
}

void Qwerty_ButtonRound36OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("n");
     } else {
         Qwerty_UpdateLabel1("N");
     }
}

void Qwerty_ButtonRound37OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("m");
     } else {
         Qwerty_UpdateLabel1("M");
     }
}

void Qwerty_ButtonRound38OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1(",");
     } else {
         Qwerty_UpdateLabel1(",");
     }
}

void Qwerty_ButtonRound39OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1(".");
     } else {
         Qwerty_UpdateLabel1(".");
     }
}

void Qwerty_ButtonRound40OnClick() {
     if (ShiftState == FALSE) {
         Qwerty_UpdateLabel1("/");
     } else {
         Qwerty_UpdateLabel1("/");
     }
}

void Qwerty_ButtonRound41OnClick() {  // Shift
     if (ShiftState == FALSE) {
        ShiftState = TRUE;
        Qwerty_ButtonRound41.Gradient_Start_Color = CL_BLUE;
     } else {
        ShiftState = FALSE;
        Qwerty_ButtonRound41.Gradient_Start_Color = CL_GRAY;
     }
     DrawRoundButton(&Qwerty_ButtonRound41);
}

void Qwerty_ButtonRound42OnClick() {  // Space
     Qwerty_UpdateLabel1(" ");
}

void Qwerty_ButtonRound43OnClick() {  // Backspace
     int len;
     
     len = strlen(CaptionBuf);        // Get the number of chars in caption buffer
     if (len != 0) {                  // Do not proceed if there are no chars
         CaptionBuf[len-1] = 0;       // Delete the end character
         Qwerty_ClearLabel(&Qwerty_Label1);  // Erase the caption of entry label
         strcpy(Qwerty_Label1.Caption,CaptionBuf);  // Set it to new value
         DrawLbl(&Qwerty_Label1);     // Re-paint the label
     }
}

void Qwerty_ButtonRound44OnClick() {  // Enter
     strcpy(myPassword,Qwerty_Label1.Caption);
     WiFiStateFuncPtr = WiFiState100;
     DrawScreen(&Screen1);
}
