typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton_Round;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Image {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Box_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox_Round;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int         ObjectsCount;
  unsigned int           Buttons_RoundCount;
  TButton_Round          * const code *Buttons_Round;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           ImagesCount;
  TImage                 * const code *Images;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           Boxes_RoundCount;
  TBox_Round             * const code *Boxes_Round;
  unsigned int           LinesCount;
  TLine                 * const code *Lines;
};

extern   TScreen                Screen1;
extern   TImage               Image1;
extern   TBox                   Box1;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TLabel                 Label3;
extern   TLine                  Line1;
extern   TLabel                 Label5;
extern   TLabel                 Label6;
extern   TLabel                 Label7;
extern   TLabel                 Label8;
extern   TLabel                 Label9;
extern   TLabel                 Label10;
extern   TLabel                 Label11;
extern   TLabel                 Label12;
extern   TLabel                 Label13;
extern   TLabel                 Label14;
extern   TLabel                 Label15;
extern   TLabel                 Label16;
extern   TLabel                 Label17;
extern   TLabel                 Label18;
extern   TLabel                 Label4;
extern   TLabel                 Label19;
extern   TButton_Round          ButtonRound1;
extern   TButton_Round          ButtonRound2;
extern   TButton_Round          ButtonRound3;
extern   TButton_Round          ButtonRound4;
extern   TButton_Round          * const code Screen1_Buttons_Round[4];
extern   TLabel                 * const code Screen1_Labels[19];
extern   TImage                 * const code Screen1_Images[1];
extern   TBox                   * const code Screen1_Boxes[1];
extern   TLine                  * const code Screen1_Lines[1];


extern   TScreen                Screen2;
extern   TBox_Round             Qwerty_BoxRound1;
extern   TButton_Round          Qwerty_ButtonRound1;
extern   TButton_Round          Qwerty_ButtonRound2;
extern   TButton_Round          Qwerty_ButtonRound3;
extern   TButton_Round          Qwerty_ButtonRound4;
extern   TButton_Round          Qwerty_ButtonRound5;
extern   TButton_Round          Qwerty_ButtonRound6;
extern   TButton_Round          Qwerty_ButtonRound7;
extern   TButton_Round          Qwerty_ButtonRound8;
extern   TButton_Round          Qwerty_ButtonRound9;
extern   TButton_Round          Qwerty_ButtonRound10;
extern   TButton_Round          Qwerty_ButtonRound11;
extern   TButton_Round          Qwerty_ButtonRound12;
extern   TButton_Round          Qwerty_ButtonRound13;
extern   TButton_Round          Qwerty_ButtonRound14;
extern   TButton_Round          Qwerty_ButtonRound15;
extern   TButton_Round          Qwerty_ButtonRound16;
extern   TButton_Round          Qwerty_ButtonRound17;
extern   TButton_Round          Qwerty_ButtonRound18;
extern   TButton_Round          Qwerty_ButtonRound19;
extern   TButton_Round          Qwerty_ButtonRound20;
extern   TButton_Round          Qwerty_ButtonRound21;
extern   TButton_Round          Qwerty_ButtonRound22;
extern   TButton_Round          Qwerty_ButtonRound23;
extern   TButton_Round          Qwerty_ButtonRound24;
extern   TButton_Round          Qwerty_ButtonRound25;
extern   TButton_Round          Qwerty_ButtonRound26;
extern   TButton_Round          Qwerty_ButtonRound27;
extern   TButton_Round          Qwerty_ButtonRound28;
extern   TButton_Round          Qwerty_ButtonRound29;
extern   TButton_Round          Qwerty_ButtonRound30;
extern   TButton_Round          Qwerty_ButtonRound31;
extern   TButton_Round          Qwerty_ButtonRound32;
extern   TButton_Round          Qwerty_ButtonRound33;
extern   TButton_Round          Qwerty_ButtonRound34;
extern   TButton_Round          Qwerty_ButtonRound35;
extern   TButton_Round          Qwerty_ButtonRound36;
extern   TButton_Round          Qwerty_ButtonRound37;
extern   TButton_Round          Qwerty_ButtonRound38;
extern   TButton_Round          Qwerty_ButtonRound39;
extern   TButton_Round          Qwerty_ButtonRound40;
extern   TButton_Round          Qwerty_ButtonRound41;
extern   TButton_Round          Qwerty_ButtonRound42;
extern   TButton_Round          Qwerty_ButtonRound43;
extern   TButton_Round          Qwerty_ButtonRound44;
extern   TLabel                 Qwerty_Label1;
extern   TLabel                 Qwerty_Label2;
extern   TButton_Round          * const code Screen2_Buttons_Round[44];
extern   TLabel                 * const code Screen2_Labels[2];
extern   TBox_Round             * const code Screen2_Boxes_Round[1];



/////////////////////////
// Events Code Declarations
void ButtonRound1OnClick();
void ButtonRound2OnClick();
void ButtonRound3OnClick();
void ButtonRound4OnClick();
void Label10OnClick();
void Label13OnClick();
void Label16OnClick();
void Label4OnClick();
void Label7OnClick();
void Qwerty_ButtonRound10OnClick();
void Qwerty_ButtonRound11OnClick();
void Qwerty_ButtonRound12OnClick();
void Qwerty_ButtonRound13OnClick();
void Qwerty_ButtonRound14OnClick();
void Qwerty_ButtonRound15OnClick();
void Qwerty_ButtonRound16OnClick();
void Qwerty_ButtonRound17OnClick();
void Qwerty_ButtonRound18OnClick();
void Qwerty_ButtonRound19OnClick();
void Qwerty_ButtonRound1OnClick();
void Qwerty_ButtonRound20OnClick();
void Qwerty_ButtonRound21OnClick();
void Qwerty_ButtonRound22OnClick();
void Qwerty_ButtonRound23OnClick();
void Qwerty_ButtonRound24OnClick();
void Qwerty_ButtonRound25OnClick();
void Qwerty_ButtonRound26OnClick();
void Qwerty_ButtonRound27OnClick();
void Qwerty_ButtonRound28OnClick();
void Qwerty_ButtonRound29OnClick();
void Qwerty_ButtonRound2OnClick();
void Qwerty_ButtonRound30OnClick();
void Qwerty_ButtonRound31OnClick();
void Qwerty_ButtonRound32OnClick();
void Qwerty_ButtonRound33OnClick();
void Qwerty_ButtonRound34OnClick();
void Qwerty_ButtonRound35OnClick();
void Qwerty_ButtonRound36OnClick();
void Qwerty_ButtonRound37OnClick();
void Qwerty_ButtonRound38OnClick();
void Qwerty_ButtonRound39OnClick();
void Qwerty_ButtonRound3OnClick();
void Qwerty_ButtonRound40OnClick();
void Qwerty_ButtonRound41OnClick();
void Qwerty_ButtonRound42OnClick();
void Qwerty_ButtonRound43OnClick();
void Qwerty_ButtonRound44OnClick();
void Qwerty_ButtonRound4OnClick();
void Qwerty_ButtonRound5OnClick();
void Qwerty_ButtonRound6OnClick();
void Qwerty_ButtonRound7OnClick();
void Qwerty_ButtonRound8OnClick();
void Qwerty_ButtonRound9OnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Image1_Caption[];
extern char Box1_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Line1_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Label14_Caption[];
extern char Label15_Caption[];
extern char Label16_Caption[];
extern char Label17_Caption[];
extern char Label18_Caption[];
extern char Label4_Caption[];
extern char Label19_Caption[];
extern char ButtonRound1_Caption[];
extern char ButtonRound2_Caption[];
extern char ButtonRound3_Caption[];
extern char ButtonRound4_Caption[];
extern char Qwerty_BoxRound1_Caption[];
extern char Qwerty_ButtonRound1_Caption[];
extern char Qwerty_ButtonRound2_Caption[];
extern char Qwerty_ButtonRound3_Caption[];
extern char Qwerty_ButtonRound4_Caption[];
extern char Qwerty_ButtonRound5_Caption[];
extern char Qwerty_ButtonRound6_Caption[];
extern char Qwerty_ButtonRound7_Caption[];
extern char Qwerty_ButtonRound8_Caption[];
extern char Qwerty_ButtonRound9_Caption[];
extern char Qwerty_ButtonRound10_Caption[];
extern char Qwerty_ButtonRound11_Caption[];
extern char Qwerty_ButtonRound12_Caption[];
extern char Qwerty_ButtonRound13_Caption[];
extern char Qwerty_ButtonRound14_Caption[];
extern char Qwerty_ButtonRound15_Caption[];
extern char Qwerty_ButtonRound16_Caption[];
extern char Qwerty_ButtonRound17_Caption[];
extern char Qwerty_ButtonRound18_Caption[];
extern char Qwerty_ButtonRound19_Caption[];
extern char Qwerty_ButtonRound20_Caption[];
extern char Qwerty_ButtonRound21_Caption[];
extern char Qwerty_ButtonRound22_Caption[];
extern char Qwerty_ButtonRound23_Caption[];
extern char Qwerty_ButtonRound24_Caption[];
extern char Qwerty_ButtonRound25_Caption[];
extern char Qwerty_ButtonRound26_Caption[];
extern char Qwerty_ButtonRound27_Caption[];
extern char Qwerty_ButtonRound28_Caption[];
extern char Qwerty_ButtonRound29_Caption[];
extern char Qwerty_ButtonRound30_Caption[];
extern char Qwerty_ButtonRound31_Caption[];
extern char Qwerty_ButtonRound32_Caption[];
extern char Qwerty_ButtonRound33_Caption[];
extern char Qwerty_ButtonRound34_Caption[];
extern char Qwerty_ButtonRound35_Caption[];
extern char Qwerty_ButtonRound36_Caption[];
extern char Qwerty_ButtonRound37_Caption[];
extern char Qwerty_ButtonRound38_Caption[];
extern char Qwerty_ButtonRound39_Caption[];
extern char Qwerty_ButtonRound40_Caption[];
extern char Qwerty_ButtonRound41_Caption[];
extern char Qwerty_ButtonRound42_Caption[];
extern char Qwerty_ButtonRound43_Caption[];
extern char Qwerty_ButtonRound44_Caption[];
extern char Qwerty_Label1_Caption[];
extern char Qwerty_Label2_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
