/*
 * Project name:
     WiFiTest.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     3/2/2013
 * Time of creation
     1:04:14 PM
 * Test configuration:
     MCU:             LM3S9B95
     Dev.Board:       mikromedia_for_Stellaris_M3
                      http://www.mikroe.com/mikromedia/stellaris-m3/
     Oscillator:      80000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 */

#include "WiFiTest_objects.h"
#include "Timer0.h"
#include "USB_Driver.h"
#include "UART0.h"
#include "WiFiPlus.h"
#include "IO.h"

void main() {

     Start_TP();                 // Initialize touch panel
     TimerInit();                // Initialize timer
     init_timerpool();           // Initialize timer pool
     USB_Init();                 // Initialize USB

     UART0Init();                // Initialize UART0
     IO_Init();                  // Initialize IO
     WiFiPlusInit();             // Initialize WiFi module

     EnableInterrupts();         // Enable interrupts

     while (1) {
         Check_TP();             // Check touch panel
         TimerCheck();           // Check 1 second tick
         USB_CheckIn();          // Check USB input
         USB_CheckOut();         // Check USB output

         UART0_Receive_Char();   // Check UART receiver
         UART0_Rx();             // Check serial input data
         UART0_Tx();             // Check serial output data
         
         WiFiApp();              // Do application state machine
     }
}
